/*
 * $Id: corpfuns.h,v 1.2 1996/05/12 23:36:15 scotty Rel $
 *
 * $Log: corpfuns.h,v $
 * Revision 1.2  1996/05/12 23:36:15  scotty
 * v927 fixes from Tony.
 *
 * Revision 1.1  1996/02/15 01:29:20  scotty
 * Initial revision
 *
 */
#ifndef CORPFUNS_H
# define CORPFUNS_H

# include "exttypes.h"
# include "corpdefs.h"

# if !defined(__unix__)
void        syslog(int, char *, ...);
void        openlog(char *, int, int);
# endif /* ! __unix__ */

# if defined(SERVER)
int __cdecl fscanf(FILE *, const char *,...);
# endif /* SERVER */

void           UtilPerform(int);
int            Menu(struct menu *);
void           BuildIndex(void);
BOOL			BuildOneIndex(char*);
void           corperr(char *, ...);
BOOL           Excluded(char *);
void           BuildHeader(void);
BOOL           is_nc(char);
FILE          *FirstFile(char *);
FILE          *NexFile(char *);
void           MergeIndex(void);
void           Sorts(void);
void           Compression(void);
void           Measure(void);
void 			IndexSig();
void           EditGetWord(char *, char *);
unsigned int   hashval(char *);
void           QueryMenu(void);
void           GetPath(char *, char *);
BOOL           AdvanceStream(struct stream *);
BOOL           XAdvanceStream(struct stream *);
void           RewindStream(struct stream *);
void           ClearBuffers(void);
void           ViewMenu(void);
void           RestorePos(struct stream *, STRSAVE *);
void           SavePos(struct stream *, STRSAVE *);
sara_long      CountStream(struct stream *);
sara_long      XCountStream(struct stream *);
void           MakeSortTab(void);
sara_long      LastSGML(WORDNO, sara_ulong, char *, int);
sara_long      NextSGML(WORDNO, sara_ulong, char *, int);
sara_long      LastSGMLp(sara_long, sara_ulong, char *, int);
sara_long      NextSGMLp(sara_long, sara_ulong, char *, int);
BOOL           ynq(char *);
void           NewQuery(void);
void           ClearBookmarks(void);
void           DiscardUnmarked(void);
void           CloseQuery(void);
void           EditGetNumber(char *, int *);
void           Retain(int, int);
struct stream *MakeAtomStream(char *, int, int);
void           WordList(void);
void           DelAllWL(void);
void           KillFileBuffers(FILE *f);
void           preproc(char *);
void           FullQuery(void);
struct stream *MakeAllPOSStream(const char *, BOOL);
struct stream *MakePosStream(char *);
struct stream *MakePosStream2(const char *,int);
struct stream *MakeAllPOSStreamN(const char **, int, BOOL);
struct stream *MakeDictionaryStream(int);
struct stream* MakeLemmaStream(const char*);
struct stream* MakeFormStream(const char*);
void           FreeStreams(void);
struct stream *GrabStream(void);
struct stream *MakeSGMLStream2(char *, int, char *[], char *[]);
struct stream *MakeFileStream(char *);
struct stream *MakeSCStream(char *);
struct stream *MakeIDStream(char *, char *, int);
struct stream *MakeIDCStream(int, WORDNO[10], char *, int);
BOOL           bMayHashChar(unsigned, char, int);
char          *IndexDir(unsigned i);
void           Server(void);
sara_long      Solve(char *, char *, int *);
sara_long      Solve0(char *, int *);
void           FreeStream(struct stream *);
int            WoL(char *);
sara_long      SaveQueryFile(struct stream *, char *, int *);
void           GetIndex(void);
int            PosList(char *, int[]);
struct stream *MakeRegExpStream(char *);
struct stream *MakeCaseFilter(struct stream *s, char *);
void           GetPath2(char *code, char *id, char *path);
void           WriteHeader2();
int				IsFrob(char*);
BOOL           IsWTag(const char*);
BOOL           IsPosTag(const char*,const char*);
BOOL           IsLemmaTag(const char*,const char*);
void           MakeElttabs(void);
void           GetName(char **, char *);
void           Dictionary(void);
void           SCDictionary(const char*);
BOOL			SCRead(char*,char*);
void SCDel(char*);
void			SCWriteAll();
void			SCReadAll();
int				SCCount();
const char*     SCName(int);
void           GetDict(void);
char          *GetQPath(char *);
char          *GetQTPath(char *);
sara_long      cscore(struct stream *, struct stream *, int);
sara_long      xscore(struct locent1 *, struct stream *, int,int);
sara_long      colloc_score(char *, char *, int,int, int*);
void           GetDocPath(sara_ulong, char *, char *);
void           GetPIndex();
void GetBIndex();
int            FindDoc(char *);
void           PackIndex();
BOOL           idcomp(char *, char *, char *, WORDNO *);
BOOL           Get1Sol(sara_ulong, char *, char *, char *);
void           TextExtract(sara_ulong, sara_long, sara_long, char *);
BOOL           SetPassword(char *, char *, char *);
BOOL           LogUser(char *name, char *password);
void           MakeFIndex(void);
void           NewSortHash(char *);
void           IndexFile(int hash, int k, char *path);
FILE          *Accelerated(char *, int, int);
void           GetAccels(void);
int            WoL1(char *);
void           WoL2(int, char *, int, sara_long *, sara_long *);
void           GetDictEntry(FILE *, sara_long, char *, int, sara_long *, sara_long *);
int            GetFirstDictEntry(char *);
char          *GetNextDictEntry();
int            NDirs(void);
int				ustrcmp(unsigned char*,unsigned char*);
int				uccmp(unsigned char,unsigned char);
extern unsigned int g_uc0;
char*          GetWordList(int);
BOOL lemmata(char*,int,char*,BOOL);
void initialise_lexrules(char*);
int LemmaNSchemes();
void LemmaSetScheme(int,BOOL);
int LemmaGetScheme();
const char* LemmaName(int);
char* LemmInfo();
void RefreshDict();
void QADSave(const char*);
void QADLoad(const char*);
void QADLims(const char*,int*,int*);
void LemmaEnable(int,char*);
BOOL LemmaIsEnabled(int);
void LemmaDescribe(int,char**);
BOOL LemmaTest(int,int,char*,char*,char*);
void SGMLFold(char*);
BOOL SGMLComp(const char*,const char*);


BOOL           CLine(char *,int*);
void           BuildMerge(void);
int            AllocBuffers(int);
void           Bibliography(void);
int            IndexAdd(FILE *, sara_ulong);
BOOL           TestInterrupt(void);
void           trace(char *, char *,...);
void           MakeFrob(void);
void           ScratchFile(char *);
BOOL Tests();
BOOL ReadDescFile(char*);
BOOL omitted(char*);
struct regexp *ParseRegExp(const char *);
BOOL pMatch(const char*,struct regexp *);

#endif /* CORPFUNS_H */
