#include "corpinc.h"



void MeasureFile(int);

void DoWord(char*,int,int,int*,long*);     

void Outputs(void);



int mrecs, mrech, trecs;

int mdics, mdich, tdics;

long mw, mwh, tw;    

long msize, msizeh, tsize;

int nopen, nuns;

long nwe; int maxw;         

char mword[MAXWORD];

int twords;

int msig, tsig; char msigh[MAXWORD];

#define MAXTWORD 1000

#define MAXTLOC 5000                               



              

char dw[MAXTWORD][MAXWORD];



int nsig[MAXTWORD];



struct

{

	int ik;

	int extra;

	int type;

} 

de[MAXTLOC];	



    

void Measure(void)

{           

	int i; 

	mrecs=0; mrech=0;

	trecs=0; nuns=0;           

	mdics=mdich=tdics=0;

	mw=mwh=tw=0;          

	msize=msizeh=tsize=0;     

	msig=tsig=0;

	twords=0;

	nopen=0; maxw=0; 

	for (i=0;i<hashrange;i++)

		MeasureFile(i);

	Outputs();

}



void MeasureFile(int i)

{

	FILE *fM;

	char word[MAXWORD]; char path[_MAX_PATH];

	int extra,type,wno; long pos, lcode;

	int nrecs=0; int j;		                     

	int ndics=0; long nw=0;     

	long nsize;                                    

	sprintf(path,"%s%i.HID",IndexDir(i),i);

	fM=fopen(path,"r");

	if (fM==NULL)

	{

		sprintf(path,"%s%i.UNS",IndexDir(i),i);

		fM=fopen(path,"r");

		if (fM==NULL) return;

		nuns++;

	}	

	nopen++; nwe=0;

	for (j=0;j<MAXTWORD;j++)

		nsig[j]=0;

	while (fscanf(fM,"%[^\t] %i %i %ld %ld %ld\n",

		word,&extra,&type,&lcode,&pos,&wno)==6)

		{   

			nrecs++;

			DoWord(word,extra,type,&ndics,&nw);

		}

	fclose(fM);

	trecs += nrecs;

	if (nrecs > mrecs)

		{

		mrecs=nrecs;

		mrech=i;

		}

	tdics += ndics;

	if (ndics > mdics)

		{

		mdics=ndics;

		mdich=i;

		}

	tw += nw;	

	if (nw > mw)

		{

		mw=nw;

		mwh=i;

		}	           

	for (j=0;j<MAXTWORD;j++)

	{

		tsig += nsig[j];

		if (nsig[j]>msig)

		{

			msig=nsig[j];

			strcpy(msigh,dw[j]);

		}		        

	}	

	nsize=sizeof (struct ihdr) + ndics * sizeof (struct dicent) +

		nrecs * sizeof (struct locent) + nw;

	tsize += nsize;

	if (nsize > msize)

	{

		msize = nsize;

		msizeh=i;

	}

	return;

}		 		                    

                               



void DoWord(char* word,int extra,int type,int *nd,long *nw)

{    

	int i, ik;

	for (i=0;i<nwe;i++)

		if (!strcmp(word,dw[i])) break;

	if (i==nwe) 

	{                   

	int l;

	strcpy(dw[nwe++],word);

	(*nw)+=(l=strlen(word))+1;

	if (nwe >= MAXTWORD) corperr("Test word table overflow",NULL);

	if (l > maxw)

		{

		maxw=l;

		strcpy(mword,word);

		}

	twords++;	

	}       

	ik=i;       

	for (i=0;i<*nd;i++)

		if (de[i].ik==ik && de[i].extra==extra&&de[i].type==type)

			break;

	if (i==*nd)

	{

		de[*nd].ik=ik;

		de[*nd].extra=extra;

		de[*nd].type=type;

		(*nd)++;   

		nsig[ik]++;

	if (*nd >= MAXTLOC) corperr("Test dictionary overflow",NULL);

	}

	return;

}			



void Outputs(void)

{   

	if (nopen==0) {printf("Run statistics before compressing index\n"); return;}

	corperr("%i non-empty hashfiles out of %i (%li%%)\n",nopen,hashrange,

		(long) nopen*100/hashrange);		                

	if (nuns>0) corperr("%i files are unsorted\n",nuns);	

	corperr("Index stats:               Average                  Max\n");

	corperr("Records per index            %5i                %5i (%i)\n",

		trecs/hashrange,mrecs,mrech);

	corperr("Words per index              %5i                %5i (%i)\n",

		tdics/hashrange,mdics,mdich);

	corperr("Char space per index         %5li                %5li (%i)\n",

		tw/hashrange,mw,mwh);		 	       

	corperr("Index size                   %5li                %5li (%i)\n",

		tsize/hashrange,msize,msizeh);        

	corperr("Entries per word             %5i                %5i (%s)\n",

		tsig/twords,msig,msigh);

	corperr("Longest word length is %i (%s)\n",maxw,mword);

	corperr("%i words in dictionary\n\n",twords);

	return;

}

			

		

	

				

			                         

		

		






