/*
 * $Id: corpqy.c,v 1.4 1996/05/12 23:36:15 scotty Rel $
 *
 * $Log: corpqy.c,v $
 * Revision 1.4  1996/05/12 23:36:15  scotty
 * v927 fixes from Tony.
 *
 * Revision 1.3  1996/03/01 23:52:17  scotty
 * Changed MAXSIG to MAX_SIG since MAXSIG is defined by Solaris.
 *
 * Revision 1.2  1996/02/14 22:01:04  scotty
 * Some fixes by Tony.
 *
 * Revision 1.1  1996/01/30 20:47:53  scotty
 * Initial revision
 *
 */
#include "corpinc.h"

//#define CASE_KLUDGE

static char rcsid[] = "$Id: corpqy.c,v 1.4 1996/05/12 23:36:15 scotty Rel $";

#define SERVER 1

sara_long      nload = 0;
BOOL           bStreamErr;

BOOL           LookUpWord(struct lookup *, int);
void           GetPos(struct lookup *);
BOOL           GetPos1(struct lookup *, int, int);
void           MakeSigDesc(int, int, char *);
void           SimpleQuery(void);
BOOL           SetPos(struct stream *);
BOOL           SetPosEnd(struct stream *);
BOOL           CalcK(struct stream *, int *, int *);
int            ReadIndex(int, int);
int            ReadIndexFile(FILE *, int);
int            ReadStreamIndex(struct stream *, int);
int            FreeBuffer(void);
void           SetLimits(struct stream *, sara_ulong);
void           NormSpaces(char *);
BOOL           SameAttribute(char *, char *, char *, char *, char *);
int            GetWords(char *, char[][MAXWORD]);
BOOL           poscmp(sara_ulong, sara_long, sara_ulong, sara_long);
BOOL           WAdStream(struct stream *, sara_ulong, WORDNO, int, BOOL);
BOOL           WAdStreamp(struct stream *, sara_ulong, sara_long, BOOL);
BOOL           WAdStreamb(struct stream *, sara_ulong, WORDNO, int, BOOL);
BOOL           WAdStreambp(struct stream *, sara_ulong, sara_long, BOOL);
void           FreeStreams(void);
void           PhraseQuery(void);
void           SaveStreamPos(struct stream *);
void           RestoreStreamPos(struct stream *);
void           Subquery(void);
void           SaveQuery(void);
void           SaveSubCorpus(void);
void           LoadQuery(void);
void           QueryOptions(void);
BOOL           bFilterCase(sara_long, sara_ulong, char *, int, int);
BOOL           RegressStream(struct stream *);
BOOL           Get1Att(char *, sara_ulong, int, WORDNO *);
BOOL		Get1AttText(sara_ulong,char*,char*,char*);

BOOL           Get1Elt(sara_ulong, char *, char *);
BOOL           bIDValOK(struct stream *s);
struct stream *AccelerateStream(char *, int, int, sara_ulong);
void           GetAccels(void);
void           LoadAccel(int);
BOOL           TestSpan(struct stream *);
struct stream* PCQStream(char* ,char* ,char* ,WORDNO );
BOOL TestSubCorpus(sara_ulong);
int DicSB(const char*);
int LastIndex(struct stream*);
int ClassifyPOS(char*);

struct stream  qs;
BOOL           bFilter;
int            filter[MAXSORTQUERY];
int            nfil;
sara_long      nuse = 0;
BOOL           bCase = FALSE;
BOOL           bHdr = FALSE;

int            BinChop(int, int, int, sara_long, WORDNO);
int            BinChopp(int, int, int, sara_long, sara_long);
int            BinChop1(int, int, int, sara_long, WORDNO);
int            BinChop1p(int, int, int, sara_long, sara_long);
int            BinChopb(int, int, int, sara_long, WORDNO);
int            BinChop1b(int, int, int, sara_long, WORDNO);
int            BinChopbp(int, int, int, sara_long, sara_long);
int            BinChop1bp(int, int, int, sara_long, sara_long);
void           FreeStream(struct stream *);
int            ReadSubCorpus(struct stream *);
BOOL			WordStream(struct stream*);

BOOL           bAutoAlloc = TRUE;

int            nba = 0;
int            nbt = 0;

BOOL           bTrace = FALSE;

struct stream *MakeAttStream(char *, char *, char *);

#define NVARS 20

struct {
   BOOL      bSet;
   int       val;
   struct stream *setter;
} vars[NVARS];

struct menu qm = {
   "Query menu",
   10,
   {
      { MN_SQUERY,   "Simple query"    },
      { MN_PHRASE,   "Phrase"          },
      { MN_WORDLIST, "Word list"       },
      { MN_SUBQUERY, "Subquery"        },
      { MN_SAVE,     "Save query"      },
      { MN_SSC,      "Save subcorpus"  },
      { MN_LOAD,     "Load query"      },
      { MN_VIEW,     "View"            },
      { MN_OPTIONS,  "Search options"  },
      { MN_MAIN,     "Main menu" }
   }
};

struct menu sqm = {
   "Sub-query menu",
   3,
   {
      { MN_DISCARD,     "Discard unmarked"   },
      { MN_SELECTION,   "Selection"          },
      { MN_MAIN,        "Query menu"         }
   }
};

struct menu oqm = {
   "Search options menu",
   2,
   {
      { MN_CASE, "Case sensitive"   },
      { MN_MAIN, "Query menu"       }
   }
};

#if !defined(SERVER)

void QueryMenu(void)
{
   while (TRUE)
      switch (Menu(&qm)) {

       case MN_SQUERY:
         if (qs.type != 0)
            CloseQuery();
         SimpleQuery();
         MakeSortTab();
         break;

       case MN_PHRASE:
         if (qs.type != 0)
            CloseQuery();
         FullQuery();
         break;

       case MN_VIEW:
         if (qs.type == 0)
            printf("No query to view\n");
         else
            ViewMenu();
         break;

       case MN_SUBQUERY:
         Subquery();
         break;

       case MN_SAVE:
         SaveQuery();
         break;

       case MN_SSC:
         SaveSubCorpus();
         break;

       case MN_LOAD:
         if (qs.type != 0)
            CloseQuery();
         LoadQuery();
         break;

       case MN_OPTIONS:
         QueryOptions();
         break;

       case MN_WORDLIST:
         WordList();
         break;

       case MN_MAIN:
         return;
      }
}


void QueryOptions(void)
{
   while (TRUE) {
      switch (Menu(&oqm)) {

       case MN_CASE:
         bCase = !bCase;
         oqm.mi[0].item = bCase ? "Case insensitive" : "Case sensitive";
         break;

       case MN_MAIN:
         return;
      }
   }
}

void SimpleQuery(void)
{
   struct lookup  lur;
   int            i,
                  n;
   char           text[MAXMENUITEM];

   NewQuery();

   EditGetWord("Enter word: ", lur.word);
   strcpy(qs.xword, lur.word);

   if (!LookUpWord(&lur, 0)) {
      preproc(lur.word);
      if (!LookUpWord(&lur, 0)) {
         printf("%s not found in dictionary\n", lur.word);
         return;
      }
   }

   GetPos(&lur);
   qs.type = TY_ATOM;
   strcpy(qs.word, lur.word);

   i = lur.sel;
   qs.ihash = lur.ihash;
   qs.count = -1;
   qs.extra = lur.sig[i].extra;
   qs.wtype = lur.sig[i].type;
   qs.first = lur.sig[i].first;
   qs.ff = lur.sig[i].ff;
   qs.last = (i + 1 < lur.nsig) ? lur.sig[i + 1].first : lur.last;
   qs.lf = (i + 1 < lur.nsig) ? lur.sig[i + 1].ff : lur.lf;
   qs.lw = strlen(lur.word);
   qs.lw0=0;

   if (bCase && qs.wtype == ID_WORD)
      MakeCaseFilter();

   n = CountStream(&qs);
   MakeSigDesc(qs.wtype, qs.extra, text);

   printf("%s (%s)\n", qs.word, text);
   printf("%i instance%s found\n", n, (n > 1 ? "s" : ""));

   return;
}


#endif /* !SERVER */


void preproc(char *s)
{
	BOOL bInEntity=FALSE;
   while (*s != 0) {
		if (*s=='&') bInEntity=TRUE;
		if (*s==';') bInEntity=FALSE;
      if (isascii(*s) && !bInEntity) *s = tolower(*s);
      s++;
   }
   return;
}


BOOL LookUpWord(struct lookup *lur, int kf)
{
   char  path[_MAX_PATH];
   int   i,
         j,
         k;
   FILE *fInd;
   off_t loff;

   lur->ihash = hashval(lur->word);

 redo:

   IndexFile(lur->ihash, kf, path);
   fInd = fopen(path, "r");
   if (fInd == NULL)
      return FALSE;

   fread(&header, sizeof(header), 1, fInd);
   fix_ihdr(&header, 1);
   if (header.version != INDEXVER) {
      corperr("Index %s wrong format", path);
      fclose(fInd);
      return FALSE;
   }

   fread(dict, sizeof(struct dicent), header.ndict, fInd);
   fix_dicent(dict, header.ndict);
   /*
    * fread(locs, sizeof(struct locent), header.nill, fInd);
    */
   loff = sizeof(header) + header.ndict * sizeof(struct dicent)
      + header.nill * sizeof(struct locent);
   fseek(fInd, (off_t)loff, SEEK_SET);
   fread(words, 1, header.nbytes, fInd);
   fclose(fInd);

   for (i = 0; i < header.ndict; i++)
#ifdef CASE_KLUDGE
		if (!stricmp(words + dict[i].dwd, lur->word))
#else
		if (!strcmp(words + dict[i].dwd, lur->word))
#endif
         break;

   if (i == header.ndict) {
      if (!header.bOS)
         return FALSE;
      else {
         kf++;
         goto redo;
      }
   }

   lur->nsig = 0;

 xb:

   if (header.ndict > 0) {
      for (j = i; j < header.ndict; j++)
#ifdef CASE_KLUDGE
         if (stricmp(words + dict[j].dwd, lur->word))
#else
         if (strcmp(words + dict[j].dwd, lur->word))
#endif
            break;

      for (k = i; k < j; k++) {
         lur->sig[lur->nsig].type = dict[k].type;
         lur->sig[lur->nsig].extra = dict[k].extra;
         lur->sig[lur->nsig].first = dict[k].first;
         lur->sig[lur->nsig++].ff = kf;
      }

      if (j < header.ndict)
         lur->last = dict[j].first;
      else
         lur->last = header.nill;
      lur->lf = kf;
   } else {
      lur->last = header.nill;
      lur->lf = kf;
      j = 0;
   }

   if (!header.bOS || j < header.ndict)
      return TRUE;
   /*
    * Now we have to read continuations
    */
   kf++;
   IndexFile(lur->ihash, kf, path);
   fInd = fopen(path, "r");
   if (fInd == NULL)
      return FALSE;

   fread(&header, sizeof(header), 1, fInd);
   fix_ihdr(&header, 1);
   if (header.version != INDEXVER) {
      corperr("Index %s wrong format", path);
      fclose(fInd);
      return FALSE;
   }
   fread(dict, sizeof(struct dicent), header.ndict, fInd);
   fix_dicent(dict, header.ndict);
   loff = sizeof(header) + header.ndict * sizeof(struct dicent)
      + header.nill * sizeof(struct locent);
   fseek(fInd, (off_t)loff, SEEK_SET);
   fread(words, 1, header.nbytes, fInd);
   fclose(fInd);

   i = 0;
   goto xb;

   return TRUE;
}

int PosList(char *w, int nsig[])
{
   struct lookup  lur;
   int            i,
                  j = 0;

   strcpy(lur.word, w);
   if (!LookUpWord(&lur, 0))
      return 0;

   for (i = 0; i < lur.nsig; i++) {
	   int e; int ii;
	   if (lur.sig[i].type != ID_WORD || lur.sig[i].extra == HDRPOS) continue;
		e=lur.sig[i].extra%10000;
		for (ii=0;ii<j;ii++)
			if (nsig[ii]==e) break;
		if (ii<j) continue;
         nsig[j++] = e;
		 }

   return j;
}


#if !defined(SERVER)

void GetPos(struct lookup *lur)
{
   int            nps = 0;
   int            i;
   char           v[sizeof(struct menu) + (sizeof(char *)) *MAX_SIG];
   struct menu   *mnu = (struct menu *) v;
   char           title[MAXMENUTITLE];
   char           mdesc[MAX_SIG][MAXMENUITEM];

   lur->sel = 0;
   if (lur->nsig == 1)
      return;

   for (i = 0; i < lur->nsig; i++) {
      mnu->mi[i].code = i;
      MakeSigDesc(lur->sig[i].type, lur->sig[i].extra, mdesc[i]);
      mnu->mi[i].item = mdesc[i];
   }

   mnu->nitems = lur->nsig;
   sprintf(title, "Part of speech menu for %s", lur->word);
   mnu->title = title;
   lur->sel = Menu(mnu);
   return;
}

#endif /* ! SERVER */

BOOL GetPos1(struct lookup *lur, int extra, int type)
{
   int   i;

   for (i = 0; i < lur->nsig; i++)
      if (lur->sig[i].extra == extra && lur->sig[i].type == type)
         break;
   lur->sel = i;

   return i < lur->nsig;
}

/*
void  MakeSigDesc(int type, int extra, char *text)
{
   int   k,
         e,
         i;
   switch (type) {

    case ID_WORD:
      if (extra >= C6OFFSET) {
         k = 1;
         e = extra - C6OFFSET;
      } else {
         k = 0;
         e = extra;
      }
      sprintf(text, "%s", postab[k][e]);
      break;

    case ID_TAGO:
      sprintf(text, "SGML open tag");
      break;

    case ID_TAGE:
      sprintf(text, "SGML close tag");
      break;

    default:
      for (i = 0; i < natts; i++)
         if (atttab[i].val == type)
            break;
      if (i == natts)
         sprintf(text, "Unknown (%i)", type);
      else
         sprintf(text, "Attribute %s of %s", atttab[i].name,
                 atttab[i].element);
      break;
   }

   return;
}
*/

#if !defined(SERVER)

void PhraseQuery(void)
{
   struct stream *qso[MAXOPS];
   char           s[MAXWORD * MAXOPS];
   int            nw;
   char           w[MAXOPS][MAXWORD];
   int            i;
   int            n;

   NewQuery();
   FreeStreams();

   EditGetWord("Enter phrase: ", s);
   nw = GetWords(s, w);

   if (nw > MAXOPS) {
      printf("Too many words\n");
      return;
   }

   for (i = 0; i < nw; i++) {
      if (!strcmp(w[i], "*")) {
         qso[i] = GrabStream();
         qso[i]->type = TY_ALL;
         continue;
      }
      qso[i] = MakeAllPOSStream(w[i]);
   }

   qs.type = TY_SEQ;
   qs.lw = -1;

   for (i = 0; i < nw; i++) {
      qs.op[i] = qso[i];
      qs.lw += qso[i]->lw + 1;
   }

   qs.ops = nw;
   strcpy(qs.word, s);
   qs.wtype = ID_ALLPOS;
   qs.count = -1;

   /*
    * qs.first=lur.sig[i].first; qs.ff=lur.sig[i].ff;
    * qs.last=(i+1<lur.nsig)?lur.sig[i+1].first:lur.last;
    * qs.lf=(i+1<lur.nsig)?lur.sig[i+1].ff:lur.lf;
    */
   n = CountStream(&qs);
   printf("%s\n", qs.word);
   printf("%i instance%s found\n", n, (n != 1 ? "s" : ""));
   return;
}


#endif /* ! SERVER */

struct stream *MakeCaseFilter(struct stream *s, char *w)
{
   struct stream *s1 = GrabStream();     
   if (s1==NULL) return NULL;

   s1->type = TY_CASE;
   s1->wc = s->wc;
   s1->op[0] = s;
   s1->ops = 0;
   strcpy(s1->xword, w);
   return s1;
}

struct stream *MakeLemmaStream(const char* word)
{
	int k=DicSB(word);
	return MakeDictionaryStream(k);
}

struct stream *MakeFormStream(const char* form)
{
	int k=0; char ff[MAXWORD]; char* t;
	strcpy(ff,form);
	if (nlt) {
		char* t=strrchr(ff,'=');
		k=atoi(t+1)-1;
		*t=0;
	}
	if (!bNoPos) {
		t=strrchr(ff,'=');
		*t=0;
		k=k*10000+ClassifyPOS(t+1);
	}
	else k=HDRPOS;
	return MakeAtomStream(ff,k,ID_WORD);
}



struct stream *MakeDictionaryStream(int k)
{
	struct strb sb; int j; struct stream *s;
    struct stream *ops[MAX_SIG]; int n0=0;
	fseek(fStreamBase,k*sizeof sb,SEEK_SET);
	while (fread(&sb,sizeof sb,1,fStreamBase)) {
		struct stream *s1=GrabStream();
		if (s1==NULL) return NULL;
		ops[n0++] = s1;
		strcpy(s1->word, GetWordList(sb.word));
		strcpy(s1->xword, GetWordList(sb.word));
		s1->type = TY_ATOM;
		s1->ihash = sb.ihash;
		s1->extra = sb.extra;
		s1->wtype = sb.type;
		s1->first = sb.first;
		s1->ff = sb.ff;
		s1->last = sb.last;
		s1->lf = sb.lf;
		s1->count = -1;
		s1->wc = 1;
		s1->lw = strlen(s1->word);
		s1->lw0=0;
		s1->frobpos=sb.frobpos;
		s1->frobno=sb.frobno;
		if (sb.bLast) break;
	}
	if (n0 == 1)
		return ops[0];

	s = GrabStream();
	if (s==NULL) return NULL;
	s->type = TY_OR;
	s->ops = n0;
	s->wc = 1;
	for (j = 0; j < n0; j++)
		s->op[j] = ops[j];
	return s;
}


struct stream *MakeAllPOSStream(const char *w, BOOL bH)
{
   struct stream *s;
   int            j;
   char           normw[MAXWORD + 1];
   int            n0 = 0;
   struct stream *ops[MAX_SIG];
   struct lookup  lur;

   strcpy(lur.word, w);
   preproc(lur.word);
   strcpy(normw, lur.word);

   if (!LookUpWord(&lur, 0))
   	  lur.nsig=0;

   for (j = 0; j < lur.nsig; j++) {
      struct stream *s1;

      if (lur.sig[j].type != ID_WORD)
         continue;
      if (!bNoPos && lur.sig[j].extra == HDRPOS && !bHdr)
         continue;
      s1 = GrabStream();

      if (!s1)
         return NULL;

      ops[n0++] = s1;
      strcpy(s1->word, lur.word);
      strcpy(s1->xword, w);
      s1->type = TY_ATOM;
      s1->ihash = lur.ihash;
      s1->extra = lur.sig[j].extra;
      s1->wtype = lur.sig[j].type;
      s1->first = lur.sig[j].first;
      s1->count = -1;
      s1->wc = 1;
      s1->ff = lur.sig[j].ff;
      s1->lw = strlen(w);
	  s1->lw0=0;

      if (j + 1 < lur.nsig) {
         s1->last = lur.sig[j + 1].first;
         s1->lf = lur.sig[j + 1].ff;
      } else {
         s1->last = lur.last;
         s1->lf = lur.lf;
      }
   }

   for (j = 0; j < nfrobpos; j++) {
      struct stream *s1;
      int            jj;

      if (strcmp(fptab[j].word, normw))
         continue;

      strcpy(lur.word, frobs[fptab[j].frob]);
      if (!LookUpWord(&lur, 0))
         continue;

      for (jj = 0; jj < lur.nsig; jj++) {
         s1 = MakeAtomStream(frobs[fptab[j].frob], lur.sig[jj].extra,
                             lur.sig[jj].type);
         if (s1 == NULL)
            continue;
         s1->frobpos = fptab[j].offset;
		 s1->frobno = j;
         s1->lw = strlen(w);
		 s1->lw0=0;
         ops[n0++] = s1;
      }
   }

   if (n0 == 0) {
#if !defined(SERVER)
      printf("Word %s not in dictionary\n", w);
#endif /* ! SERVER */
      return NULL;
   }

   if (n0 == 1)
      return ops[0];

   s = GrabStream();
   if (s==NULL) return NULL;
   strcpy(s->xword, w);
   s->type = TY_OR;
   s->ops = n0;
   s->wc = 1;

   for (j = 0; j < n0; j++)
      s->op[j] = ops[j];

   return s;
}

struct stream *MakePosStream2(const char *w, int extra)
{
   struct stream *s;
   int            j;
   char           normw[MAXWORD + 1];
   int            n0 = 0;
   struct stream *ops[MAX_SIG];
   struct lookup  lur;

   strcpy(lur.word, w);
   preproc(lur.word);
   strcpy(normw, lur.word);

   if (!LookUpWord(&lur, 0))
   	  lur.nsig=0;

   for (j = 0; j < lur.nsig; j++) {
      struct stream *s1;

      if (lur.sig[j].type != ID_WORD)
         continue;
      if (lur.sig[j].extra%10000 != extra)
         continue;
      s1 = GrabStream();

      if (!s1)
         return NULL;

      ops[n0++] = s1;
      strcpy(s1->word, lur.word);
      strcpy(s1->xword, w);
      s1->type = TY_ATOM;
      s1->ihash = lur.ihash;
      s1->extra = lur.sig[j].extra;
      s1->wtype = lur.sig[j].type;
      s1->first = lur.sig[j].first;
      s1->count = -1;
      s1->wc = 1;
      s1->ff = lur.sig[j].ff;
      s1->lw = strlen(w);
	  s1->lw0=0;

      if (j + 1 < lur.nsig) {
         s1->last = lur.sig[j + 1].first;
         s1->lf = lur.sig[j + 1].ff;
      } else {
         s1->last = lur.last;
         s1->lf = lur.lf;
      }
   }

   if (n0 == 1)
      return ops[0];

   s = GrabStream();
   if (s==NULL) return NULL;
   strcpy(s->xword, w);
   s->type = TY_OR;
   s->ops = n0;
   s->wc = 1;

   for (j = 0; j < n0; j++)
      s->op[j] = ops[j];

   return s;
}

struct stream *MakeAllPOSStreamN(const char **w, int kk, BOOL bH)
{
   struct stream *s;
   int            j;
   char           normw[MAXWORD + 1];
   int            n0 = 0;
   struct stream *ops[MAX_SIG];
   struct lookup  lur; int ii;

   for (ii=0;ii<kk;ii++) {
   strcpy(lur.word, w[ii]);
   preproc(lur.word);
   strcpy(normw, lur.word);

   if (!LookUpWord(&lur, 0))
   	  lur.nsig=0;

   for (j = 0; j < lur.nsig; j++) {
      struct stream *s1;

      if (lur.sig[j].type != ID_WORD)
         continue;
      if (!bNoPos && lur.sig[j].extra == HDRPOS && !bHdr)
         continue;
      s1 = GrabStream();

      if (!s1)
         return NULL;

      ops[n0++] = s1;
      strcpy(s1->word, lur.word);
      strcpy(s1->xword, w[ii]);
      s1->type = TY_ATOM;
      s1->ihash = lur.ihash;
      s1->extra = lur.sig[j].extra;
      s1->wtype = lur.sig[j].type;
      s1->first = lur.sig[j].first;
      s1->count = -1;
      s1->wc = 1;
      s1->ff = lur.sig[j].ff;
      s1->lw = strlen(w[ii]);
	  s1->lw0=0;

      if (j + 1 < lur.nsig) {
         s1->last = lur.sig[j + 1].first;
         s1->lf = lur.sig[j + 1].ff;
      } else {
         s1->last = lur.last;
         s1->lf = lur.lf;
      }
   }
   

   for (j = 0; j < nfrobpos; j++) {
      struct stream *s1;
      int            jj;

      if (strcmp(fptab[j].word, normw))
         continue;

      strcpy(lur.word, frobs[fptab[j].frob]);
      if (!LookUpWord(&lur, 0))
         continue;

      for (jj = 0; jj < lur.nsig; jj++) {
         s1 = MakeAtomStream(frobs[fptab[j].frob], lur.sig[jj].extra,
                             lur.sig[jj].type);
         if (s1 == NULL)
            continue;
         s1->frobpos = fptab[j].offset;
		 s1->frobno = j;
         s1->lw = strlen(w[ii]);
		 s1->lw0=0;
         ops[n0++] = s1;
      }
   }
   }
   if (n0 == 0) {
#if !defined(SERVER)
      printf("Word %s not in dictionary\n", w);
#endif /* ! SERVER */
      return NULL;
   }

   if (n0 == 1)
      return ops[0];

   s = GrabStream();
   if (s==NULL) return NULL;
   strcpy(s->xword, "");
   s->type = TY_OR;
   s->ops = n0;
   s->wc = 1;

   for (j = 0; j < n0; j++)
      s->op[j] = ops[j];

   return s;
}


sara_long CountStream(struct stream *s)
{
   sara_long   n;
   sara_long   c;
   int         i;

   if (s->count >= 0)
      return s->count;

   switch (s->type) {

    case TY_ATOM:
      if (s->lf > s->ff)
         c = (  s->last + (maxiloc - s->first)
              + ((sara_long) maxiloc) * (s->lf - s->ff - 1));
      else
         c = s->last - s->first;
      break;

    case TY_OR:
      n = 0;
      for (i = 0; i < s->ops; i++)
         n += CountStream(s->op[i]);
      c = n;
      break;

    case TY_ALL:
      c = 0;                    /* cheat */
      break;

    default:
      n = 0;
      RewindStream(s);
      while (XAdvanceStream(s))
         n++;
      c = n;
      break;
   }

   s->count = c;
   return c;
}

sara_long XCountStream(struct stream *s)
{
   sara_long   n=0;
   while (XAdvanceStream(s))
         n++;
   return n;
}


void ThrashStream(struct stream *s)
{
   RewindStream(s);
   while (AdvanceStream(s));
   return;
}


void RewindStream(struct stream *s)
{
   int   i;

   switch (s->type) {

    case TY_ATOM:               /* FALLTHROUGH */
    case TY_FILE:               /* FALLTHROUGH */
    case TY_SUBCORPUS:
      s->cursor = -1;
      SetPos(s);
      return;

    case TY_ALL:                /* FALLTHROUGH */
    case TY_NEG:
      s->wpos = -1;
      s->pos = 0;
      s->lcode = 0;
      return;

    default:
      s->wpos = -1;
      s->pos = 0;
      s->lcode = 0;

      for (i = 0; i < s->ops; i++)
         RewindStream(s->op[i]);

      return;
   }
}


void WindStream(struct stream *s)
{
   int   i;

   switch (s->type) {
    case TY_ATOM:               /* FALLTHROUGH */
    case TY_FILE:               /* FALLTHROUGH */
    case TY_SUBCORPUS:
      SetPosEnd(s);
      return;

    case TY_ALL:
      s->wpos = -1;
      s->pos = 0;
      s->lcode = 0;
      return;

    default:
      s->wpos = -1;
      s->pos = 0;
      s->lcode = 0;

      for (i = 0; i < s->ops; i++)
         WindStream(s->op[i]);

      return;
   }
}


BOOL XAdvanceStream(struct stream *s)
{
   int   i;

   for (i = 0; i < NVARS; i++) {
      vars[i].bSet = FALSE;
      vars[i].setter = NULL;
   }

   while (AdvanceStream(s)) {
	   if (TestSubCorpus(s->lcode)) return TRUE;
   }
   return FALSE;
}


void CopyProps(struct stream *s, int ii)
{
   s->pos = s->op[ii]->pos;
   s->wpos = s->op[ii]->wpos;
   s->lcode = s->op[ii]->lcode;
   s->lw = s->op[ii]->lw;
   s->lw0=s->op[ii]->lw0;
   s->wc = s->op[ii]->wc;
   s->frobno = s->op[ii]->frobno;
}                     

void FakePos(struct stream* s,sara_long p)
{
	if (s->type==TY_ALL) s->pos=p;
}	


BOOL IsMarkup(struct stream *s)
{
   return s->wtype != ID_WORD;
}

BOOL CompatFrob(int f1,int f2)
{
	if (f1 < 0 && f2 < 0) return TRUE;
	if (f1 < 0) return fptab[f2].b1;
	if (f2 < 0) return fptab[f1].b2;
	return f2==f1;
}


void NextWord(struct stream *s,int* i0,int* f0)
{
	int n=s->frobno;
	if (n<0|| fptab[n].b2) {
		*i0= s->wpos+s->wc;
		*f0=-1;
	} else {
		*i0=s->wpos;
		*f0=n+1;
	}
}

void PrevWord(struct stream *s, int* i1, int* f1, BOOL* b)
{
	int n=s->frobno;
	if (n<0 || fptab[n].b1) {
		*b=TRUE;
		*i1=s->wpos;
		*f1=-1;
	} else {
		*b=FALSE;
		*i1=s->wpos;
		*f1=n-1;
	}
}


BOOL AdvanceStream(struct stream *s)
{
   BOOL           b,
                  b1,
                  bAll;
   sara_ulong     maxcode;
   sara_long      maxpos;
   int            i,
                  ii;
   sara_ulong     mincode;
   sara_long      minpos;
   WORDNO         i0,
                  i1;
   int f0,f1;
   BOOL				bStrict;

   if (TestInterrupt())
      return FALSE;

   switch (s->type) {
    case TY_ATOM:               /* FALLTHROUGH */
    case TY_FILE:               /* FALLTHROUGH */
    case TY_SUBCORPUS:
      if (s->cursor >= CountStream(s))
         return FALSE;
      s->cursor++;
      return SetPos(s);

    case TY_ID:
      if (vars[s->kvar].bSet && vars[s->kvar].setter != s) {
         do {
            if (!AdvanceStream(s->op[0]))
               return FALSE;
         } while (s->op[0]->wpos != vars[s->kvar].val);
      } else {
         if (!AdvanceStream(s->op[0]))
            return FALSE;
         vars[s->kvar].bSet = TRUE;
         vars[s->kvar].setter = s;
         vars[s->kvar].val = (int) s->op[0]->wpos;
      }
      CopyProps(s, 0);
      return TRUE;

    case TY_IDC:
      do
         if (!AdvanceStream(s->op[0]))
            return FALSE;
      while (!bIDValOK(s));
      CopyProps(s, 0);
      return TRUE;

    case TY_AND:
      while (TRUE) {
         maxcode = 0;
         maxpos = -1;
         ii = -1;
         for (i = 0; i < s->ops; i++) {
            if (!AdvanceStream(s->op[i]))
               return FALSE;
            if (poscmp(s->op[i]->lcode, s->op[i]->pos, maxcode, maxpos)) {
               maxcode = s->op[i]->lcode;
               maxpos = s->op[i]->pos;
               ii = i;
            }
         }

         for (i = 0; i < s->ops; i++) {
            if (i == ii)
               continue;
            if (!WAdStreamp(s->op[i], maxcode, maxpos, FALSE))
               return FALSE;
            if (s->op[i]->pos != maxpos || s->op[i]->lcode != maxcode)
               break;
         }

         if (i < s->ops)
            continue;
         CopyProps(s, ii);
         return TRUE;
      }

    case TY_OR:
      ii = -1;
      mincode = 0x1000000L;
      minpos = 0x1000000L;
      for (i = 0; i < s->ops; i++) {
         if (   !poscmp(s->op[i]->lcode, s->op[i]->pos,
                        s->lcode, s->pos)
             || (s->op[i]->type == TY_ATOM && s->op[i]->cursor == -1))
            if (!AdvanceStream(s->op[i]))
               continue;
         if (poscmp(mincode, minpos, s->op[i]->lcode, s->op[i]->pos)) {
            ii = i;
            mincode = s->op[i]->lcode;
            minpos = s->op[i]->pos;
         }
      }

      if (ii < 0)
         return FALSE;

      s->pos = s->op[ii]->pos;
      s->wpos = s->op[ii]->wpos;
      s->lcode = s->op[ii]->lcode;
      s->lw = s->op[ii]->lw;
	  s->lw0=s->op[ii]->lw0;
      s->wc = s->op[ii]->wc;
	  s->frobno=s->op[ii]->frobno;
      return TRUE;

    case TY_ALL:                /* FALLTHROUGH */
    case TY_NEG:
      s->wpos++;
      return TRUE;

    case TY_SEQ:
      bAll = TRUE;
      for (i = 0; i < s->ops; i++) {
         if (s->op[i]->bOptional)
            if (s->op[i]->cursor == -1)
               AdvanceStream(s->op[i]);
            else;
         else
            bAll &= AdvanceStream(s->op[i]);
      }

    xd:

      if (!bAll)
         return FALSE;
      maxcode = 0;
      maxpos = 0;
      ii = -1;
      for (i = 0; i < s->ops; i++)
         if (!s->op[i]->bOptional && s->op[i]->type != TY_NEG
             && poscmp(s->op[i]->lcode, s->op[i]->pos,
                       maxcode, maxpos)) {
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
            ii = i;
         }
//      wi = s->op[ii]->wpos;
      b = TRUE;
      if (bTrace)
         trace("SEQ", "Stream %d wins at %ld, %ld",
               ii, maxcode, maxpos);
//      i0 = wi + s->op[ii]->wc;
		NextWord(s->op[ii],&i0,&f0);
      for (i = ii + 1; i < s->ops; i++) {
         BOOL  b2;

         b1 = b2 = WAdStream(s->op[i], maxcode, i0, f0, FALSE);     
         if (b1) FakePos(s->op[i],s->op[i-1]->pos+1);
         b1 &= (s->op[i]->wpos == i0) && (s->op[i]->lcode == maxcode)
             && (s->op[i]->pos>s->op[i - 1]->pos) && CompatFrob(f0,s->op[i]->frobno) ; 
         if (bTrace)
            if (b1)
               trace("SEQ", "Fitted %d", i);
            else
               trace("SEQ", "Failed fit %d", i);
         if (!b1 && s->op[i]->bOptional)
            continue;
         b &= b1;
         bAll &= b2;
         if (b)
            NextWord(s->op[i],&i0,&f0);
      }
      PrevWord(s->op[ii],&i1,&f1,&bStrict);

      for (i = ii - 1; i >= 0; i--) {
         BOOL  b2;

         b1 = b2 = WAdStream(s->op[i], maxcode, i1, f1, bStrict);
         if (b1) FakePos(s->op[i],s->op[i+1]->pos-1);
         if (bTrace)
            if (b1)
               trace("SEQ", "Fitted %d", i);
            else
               trace("SEQ", "Failed fit %d", i);
			b1 &= (s->op[i]->wpos + (bStrict?s->op[i]->wc:0) == i1)
            && (s->op[i]->lcode == maxcode)
            && (s->op[i]->pos<s->op[i + 1]->pos) && CompatFrob(s->op[i]->frobno,f1);

         if (!b1 && s->op[i]->bOptional)
            continue;
         b &= b1;
         bAll &= b2;
         if (b)
//            i1 -= s->op[i]->wc;
				PrevWord(s->op[i],&i1,&f1,&bStrict);
      }

      if (!b) {
         bAll &= AdvanceStream(s->op[ii]);
         goto xd;
      }
      s->pos = s->op[0]->pos;
      s->wpos = s->op[0]->wpos;
      s->lcode = s->op[0]->lcode;
      s->lw = (int) ((s->op[LastIndex(s)]->pos) - (s->op[0]->pos))
         + (s->op[LastIndex(s)]->lw);
	  s->lw0= (int) ((s->op[LastIndex(s)]->pos) - (s->op[0]->pos));
      s->wc = (int) (i0 - i1);
      return TRUE;

    case TY_LIMIT:
      if (s->limtype == LT_SGML) {
         while (AdvanceStream(s->op[0])) {
            SetLimits(s->limit1, s->op[0]->lcode);
            SetLimits(s->limit2, s->op[0]->lcode);
            WindStream(s->limit1);
			RewindStream(s->limit2); /* new */

            if (!WAdStreambp(s->limit1, s->op[0]->lcode,
                             s->op[0]->pos, FALSE))
               continue;
            RewindStream(s->limit2);
            if (!WAdStreamp(s->limit2, s->limit1->lcode,
                            s->limit1->pos, FALSE))
               continue;
            if (s->limit2->lcode != s->op[0]->lcode ||
                s->limit2->pos < s->op[0]->pos)
               continue;
            s->pos = s->op[0]->pos;
            s->wpos = s->op[0]->wpos;
            s->lcode = s->op[0]->lcode;
            s->lw = s->op[0]->lw;
            s->lw0 = s->op[0]->lw0;
            s->wc = s->op[0]->wc;
            return TRUE;
         }

         return FALSE;
      } else {                  /* SGML outside */
         while (AdvanceStream(s->op[0])) {
            WORDNO      w0,
                        wlim;
            sara_ulong  lc;

            lc = s->op[0]->lcode;

            WindStream(s->limit1);
            if (   !WAdStreamb(s->limit1, lc, s->op[0]->wpos, -1, FALSE)
                || s->limit1->lcode != lc)
               w0 = 0;
            else
               w0 = s->op[0]->wpos;
            RewindStream(s->limit2);

            if (   !WAdStream(s->limit2, lc, w0, -1, FALSE)
                || s->limit2->lcode != lc)
               wlim = 0xfffffff;
            else
               wlim = s->limit2->wpos;

            if (s->op[0]->wpos > wlim)
               continue;
            s->pos = s->op[0]->pos;
            s->wpos = s->op[0]->wpos;
            s->lcode = s->op[0]->lcode;
            s->lw = s->op[0]->lw;
            s->lw0 = s->op[0]->lw0;
            s->wc = s->op[0]->wc;
            return TRUE;
         }

         return FALSE;
      }

    case TY_PROD:
      if (s->limtype == LT_SGML)
         RewindStream(s->limit2);
      while (TRUE) {
         WORDNO      w0,
                     wx,
                     wlim;
         BOOL        bOK;
         int         ni = 0;
         int         nd;
         sara_long   p0;
         sara_long   px;
         sara_long   plim;
         sara_ulong  maxcode;
         WORDNO      maxw;
         int         ii;
      /* sara_ulong  nt; */

         bOK = FALSE;
         maxcode = 0;
         maxw = 0;
         ii = -1;

         /* Advance the last stream, which is the solution value. */

         if (!AdvanceStream(s->op[s->ops - 1]))
            return FALSE;

         /* Use the result to fix the limit values */
         switch (s->limtype) {

          case LT_SGML:
            maxcode = s->op[s->ops - 1]->lcode;
            px = s->op[s->ops - 1]->pos;
            SetLimits(s->limit1, maxcode);
            SetLimits(s->limit2, maxcode);
            WindStream(s->limit1);
			RewindStream(s->limit2); /* new */
            if (!WAdStreambp(s->limit1, maxcode, px, FALSE))
               break;

            wx = w0 = s->limit1->wpos;
            p0 = s->limit1->pos;
            nd = 1;

            if (!WAdStreamp(s->limit2, maxcode, p0 + 1, FALSE))
               break;

            plim = s->limit2->pos;
            wlim = s->limit2->wpos;

            if (s->limit2->lcode != maxcode || plim < px)
               break;

            bOK = TRUE;
            break;

          case LT_XSGML:
            WindStream(s->limit1);
            if (   !WAdStreamb(s->limit1, maxcode, maxw, -1, FALSE)
                || s->limit1->lcode != maxcode)
               w0 = 0;
            else
               w0 = s->limit1->wpos;

            if (   !WAdStream(s->limit2, maxcode, w0 + 1, -1, FALSE)
                || s->limit2->lcode != maxcode)
               wlim = 0x7fffffff;
            else {
               wlim = s->limit2->wpos;
               if (wlim < maxw)
                  break;
            }

            bOK = TRUE;
            break;

          case LT_NULL:
            p0 = 0;
            plim = 0x7fffffff;
            maxcode = s->op[s->ops - 1]->lcode;
            bOK = TRUE;
            break;

          case LT_INT:
            p0 = 0;
            plim = 0x7fffffff;
            maxcode = s->op[s->ops - 1]->lcode;
            w0 = s->op[s->ops - 1]->wpos - s->limint;
            wlim = s->op[s->ops - 1]->wpos;
            bOK = TRUE;
         }

         if (!bOK)
            continue;
         /* Now fit all the other streams in backwards */
         if (   s->op[s->ops - 1]->lcode != maxcode
             || s->op[s->ops - 1]->pos > plim)
            continue;

         for (i = s->ops - 2; i >= 0; i--) {
            WindStream(s->op[i]);
            if (   !WAdStreambp(s->op[i], s->op[i + 1]->lcode,
                                s->op[i + 1]->pos - 1, FALSE))
               break;

            if (s->op[i]->lcode != maxcode ||
                s->op[i]->pos < p0)
               break;

            if (s->limtype == LT_INT && s->op[i]->wpos <= w0)
               break;

            if (s->limtype == LT_SGML && s->op[i]->pos > s->limit2->pos)
               break;
         }

         if (i >= 0)
            continue;

         s->pos = s->op[s->ops - 1]->pos;
         s->wpos = s->op[s->ops - 1]->wpos;
         s->lcode = s->op[s->ops - 1]->lcode;
         s->lw = s->op[s->ops - 1]->lw;
         s->lw0 = s->op[s->ops - 1]->lw0;
         s->wc = (int) (  s->op[s->ops - 1]->wc
                        + s->op[s->ops - 1]->wpos - s->wpos);
         return TRUE;
      }

      return FALSE;

    case TY_BPROD:
      if (s->limtype == LT_SGML)
         RewindStream(s->limit2);

      while (TRUE) {
         WORDNO      w0,
                     wx,
                     wlim;
         BOOL        bOK;
         int         ni = 0;
         int         nd;
         sara_long   p0;
         sara_long   px;
         sara_long   plim;
         sara_ulong  maxcode;
         WORDNO      maxw;
         int         ii;
      /* sara_ulong  nt; */

         bOK = FALSE;
         maxcode = 0;
         maxw = 0;
         ii = -1;

         /* Advance the last stream, which is the solution value. */
         if (!AdvanceStream(s->op[s->ops - 1]))
            return FALSE;

         /* Use the result to fix the limit values */
         switch (s->limtype) {

          case LT_SGML:
            maxcode = s->op[s->ops - 1]->lcode;
            SetLimits(s->limit1, maxcode);
            SetLimits(s->limit2, maxcode);
            WindStream(s->limit1);
   			RewindStream(s->limit2); /* new */

            px = s->op[s->ops - 1]->pos;

            if (!WAdStreambp(s->limit1, maxcode, px, FALSE))
               break;

            wx = w0 = s->limit1->wpos;
            p0 = s->limit1->pos;
            nd = 1;

            if (!WAdStreamp(s->limit2, maxcode, p0 + 1, FALSE))
               break;

            plim = s->limit2->pos;
            wlim = s->limit2->wpos;

            if (s->limit2->lcode != maxcode || plim < px)
               break;

            bOK = TRUE;
            break;

          case LT_XSGML:
            WindStream(s->limit1);
            if (   !WAdStreamb(s->limit1, maxcode, maxw, -1, FALSE)
                || s->limit1->lcode != maxcode)
               w0 = 0;
            else
               w0 = s->limit1->wpos;

            if (   !WAdStream(s->limit2, maxcode, w0 + 1, -1, FALSE)
                || s->limit2->lcode != maxcode)
               wlim = 0x7fffffff;
            else {
               wlim = s->limit2->wpos;
               if (wlim < maxw)
                  break;
            }

            bOK = TRUE;
            break;

          case LT_NULL:
            p0 = 0;
            plim = 0x7fffffff;
            maxcode = s->op[s->ops - 1]->lcode;
            bOK = TRUE;
            break;

          case LT_INT:
            p0 = 0;
            plim = 0x7fffffff;
            maxcode = s->op[s->ops - 1]->lcode;
            w0 = s->op[s->ops - 1]->wpos - s->limint;
            wlim = s->op[s->ops - 1]->wpos + s->limint;
            bOK = TRUE;
         }
         if (!bOK)
            continue;

         /* Now fit all the other streams in backwards */
         if (   s->op[s->ops - 1]->lcode != maxcode
             || s->op[s->ops - 1]->pos > plim)
            continue;

         for (i = s->ops - 2; i >= 0; i--) {
            WindStream(s->op[i]);
            if (s->limtype == LT_INT)
               if (!WAdStreamb(s->op[i], maxcode, wlim, -1, FALSE))
                  break;
               else;
            else if (!WAdStreambp(s->op[i], maxcode, plim, FALSE))
               break;

            if (   s->op[i]->lcode != maxcode
                || s->op[i]->pos < p0)
               break;
            if (s->limtype == LT_INT && s->op[i]->wpos < w0)
               break;
         }

         if (i >= 0)
            continue;
         if (s->limtype == LT_INT && !TestSpan(s))
            continue;
         s->pos = s->op[s->ops - 1]->pos;
         s->wpos = s->op[s->ops - 1]->wpos;
         s->lcode = s->op[s->ops - 1]->lcode;
         s->lw = s->op[s->ops - 1]->lw;
         s->lw0 = s->op[s->ops - 1]->lw0;
         s->wc = (int) (  s->op[s->ops - 1]->wc
                        + s->op[s->ops - 1]->wpos - s->wpos);
         return TRUE;
      }

      return FALSE;

    case TY_CASE:
      do
         if (!AdvanceStream(s->op[0]))
            return FALSE;
      while (!bFilterCase(s->op[0]->pos, s->op[0]->lcode,
                          s->xword, s->op[0]->frobpos, s->op[0]->lw));
      CopyProps(s, 0);
      return TRUE;
   }
   return TRUE; // unused
}


BOOL TestSpan(struct stream *s)
{
   int         nw;
   int         n;
   int         i;
   sara_long   imax;
   sara_long   imin;

   nw = s->limint;
   n = s->ops;
   imax = 0;
   imin = 0x7fffffff;

   for (i = 0; i < n; i++) {
      if (s->op[i]->wpos > imax)
         imax = s->op[i]->wpos;
      if (s->op[i]->wpos < imin)
         imin = s->op[i]->wpos;
   }

   return imax - imin + 1 <= nw;
}


BOOL bIDValOK(struct stream *s)
{
   int   i;

   for (i = 0; i < s->nkvals; i++)
      if (s->op[0]->wpos == s->kval[i])
         return TRUE;

   return FALSE;
}


BOOL RegressStream(struct stream *s)
{
   switch (s->type) {
    case TY_ATOM:               /* FALLTHROUGH */
    case TY_FILE:               /* FALLTHROUGH */
    case TY_SUBCORPUS:
      s->cursor--;
      return SetPos(s);

    default:
      return FALSE;
   }
}


void CloseQuery()
{
   switch (qs.type) {
    case TY_FILE:
      KillFileBuffers(qs.handle);
      fclose(qs.handle);
      break;
   }

   qs.type = 0;
   return;
}


BOOL poscmp(sara_ulong code1, sara_long pos1, sara_ulong code2,
            sara_long pos2)
{
   sara_long  i = code1 - code2;

   return i > 0 || (i == 0 && pos1 > pos2);
}


int GetWords(char *s, char w[][MAXWORD])
{
   int   i = 0,
         j;

   while (i < MAXOPS) {
      while (isspace(*s) && *s != 0)
         s++;
      if (*s == 0)
         break;
      j = 0;
      while (!isspace(*s) && *s != 0)
         if (i < MAXOPS)
            w[i][j++] = *(s++);
      if (i < MAXOPS)
         w[i++][j] = 0;
      if (*s == 0)
         break;
   }

   return i;
}


#if defined(__unix__)
# define NSTREAMS 400
#else /* ! __unix__ */
# define NSTREAMS 400
#endif /* __unix__ */

static struct {
   BOOL      bUsed;
   struct stream s;
} ss[NSTREAMS];

struct stream *GrabStream(void)
{
   int   i;

   for (i = 0; i < NSTREAMS; i++)
      if (!ss[i].bUsed)
         break;

   if (i >= NSTREAMS) {
      bStreamErr = TRUE;
	  assert(FALSE);
      return NULL;
   }

   ss[i].bUsed = TRUE;
   ss[i].s.count = -1;
   ss[i].s.wtype = ID_WORD;
   ss[i].s.bOptional = FALSE;
   ss[i].s.limtype = LT_NULL;
   ss[i].s.ops = 0;
   ss[i].s.bFilter = FALSE;
   ss[i].s.cursor = -1;
   ss[i].s.frobpos = 0;
   ss[i].s.frobno = -1;

   return &ss[i].s;
}


void FreeStreams(void)
{
   int   i;

   for (i = 0; i < NSTREAMS; i++)
      ss[i].bUsed = FALSE;

   return;
}


void FreeStream(struct stream *s)
{
   int   i;

   for (i = 0; i < NSTREAMS; i++)
      if (s == &ss[i].s)
         ss[i].bUsed = FALSE;

   return;
}


void SaveStreamPos(struct stream *s)
{
   int   i;

   for (i = 0; i < s->ops; i++)
      SaveStreamPos(s->op[i]);
   s->oldcursor = s->cursor;
   s->oldpos = s->pos;
   s->oldwpos = s->wpos;
   s->oldlcode = s->lcode;

   return;
}


void RestoreStreamPos(struct stream *s)
{
   int   i;

   for (i = 0; i < s->ops; i++)
      RestoreStreamPos(s->op[i]);
   s->cursor = s->oldcursor;
   s->pos = s->oldpos;
   s->wpos = s->oldwpos;
   s->lcode = s->oldlcode;

   return;
}


#if defined(__unix__)
# define NBUFF 1000
#else /* ! __unix__ */
# define NBUFF 400
#endif /* __unix__ */

union bpage {
   struct locent  locs[MAXILOC0];
   struct locent1 locs1[MAXILOC0];
};

union bpage   *b[NBUFF];

int AllocBuffers(int nb)
{
   int   i;

   bAutoAlloc = FALSE;
   for (i = 0; i < nb; i++) {
      b[i + nba] = (union bpage *) malloc(sizeof(union bpage));
      if (b[i + nba] == NULL)
         return nbt = i + nba;
   }

   return nbt = nb + nba;
}

sara_ulong     scbuff[MAXSC];
FILE          *scbowner;

BOOL WAdStream(struct stream *s, sara_ulong cc, WORDNO w, int frobno, BOOL bEnd)
{
   int            kf;
   int            i;
   int            j;
   sara_long      n;
   int            kp;
   int            kq;
   WORDNO         lw;
   int            ii;
   sara_ulong     mincode;
   sara_ulong     maxcode;
   sara_long      minpos;
   sara_long      maxpos;
   BOOL           bb;

   switch (s->type) {

    case TY_ATOM:
      if (s->cursor == -1)
         AdvanceStream(s);

      if (bEnd && WordStream(s))
         w--;

	if (s->frobno != -1 && frobno != -1 && s->frobno < frobno) w++;

	if ((s->wpos >= w && s->lcode == cc) || s->lcode > cc)
         return TRUE;

      CalcK(s, &kf, &kp);
      kp++;
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf < s->lf) {
         sara_long  ic = cc - b[i]->locs[maxiloc - 1].lcode;

         lw = b[i]->locs[maxiloc - 1].word;
         if (ic < 0 || (ic == 0 && lw >= w))
            break;

         kf++;
         i = ReadStreamIndex(s, kf);
         n += maxiloc - kp;
         kp = 0;
      }
      kq = maxiloc;

      if (kf == s->lf) {
         sara_long  ic = cc - b[i]->locs[s->last - 1].lcode;

         lw = b[i]->locs[s->last - 1].word;
         if (ic > 0 || (ic == 0 && lw < w))
            return FALSE;

         kq = s->last;
      }

      j = BinChop(i, kp, kq - 1, cc, w);
      n += j - kp + 1;
      s->cursor = n;
      return SetPos(s);

    case TY_FILE:
      if (s->cursor == -1)
         AdvanceStream(s);

      if (bEnd && WordStream(s))
         w--;

      if ((s->wpos >= w && s->lcode == cc) || s->lcode > cc)
         return TRUE;

      CalcK(s, &kf, &kp);
      kp++;
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf < s->lf) {
         sara_long  ic = cc - b[i]->locs1[maxiloc - 1].lcode;

         lw = b[i]->locs1[maxiloc - 1].word;
         if (ic < 0 || (ic == 0 && lw >= w))
            break;
         kf++;
         i = ReadStreamIndex(s, kf);
         n += maxiloc - kp;
         kp = 0;
      }
      kq = maxiloc;

      if (kf == s->lf) {
         sara_long  ic = cc - b[i]->locs1[s->last - 1].lcode;

         lw = b[i]->locs1[s->last - 1].word;
         if (ic > 0 || (ic == 0 && lw < w))
            return FALSE;
         kq = s->last;
      }
      j = BinChop1(i, kp, kq - 1, cc, w);
      n += j - kp + 1;
      s->cursor = n;
      SetPos(s);
      return TRUE;

    case TY_SUBCORPUS:
      i = ReadSubCorpus(s);
      for (j = 0; j < i; j++)
         if (scbuff[j] >= cc)
            break;
      if (j == i)
         return FALSE;
      s->cursor = j;
      SetPos(s);
      return TRUE;

    case TY_OR:
      ii = -1;
      mincode = 0x1000000L;
      minpos = 0x1000000L;
      for (i = 0; i < s->ops; i++) {
         if (!WAdStream(s->op[i], cc, w, frobno, bEnd))
            continue;
         if (poscmp(mincode, minpos, s->op[i]->lcode, s->op[i]->pos)) {
            ii = i;
            mincode = s->op[i]->lcode;
            minpos = s->op[i]->pos;
         }
      }

      if (ii < 0)
         return FALSE;
      s->pos = s->op[ii]->pos;
      s->wpos = s->op[ii]->wpos;
      s->lcode = s->op[ii]->lcode;
	  s->frobno = s->op[ii]->frobno;
      return TRUE;

    case TY_ALL:
      if (bEnd)
         w--;
      s->lcode = cc;
      s->wpos = w;
      s->wc = 1;
      return TRUE;

    case TY_NEG:
      if (bEnd)
         w--;
      SaveStreamPos(s->op[0]);

      while (WAdStream(s->op[0], cc, w, frobno, bEnd) && s->op[0]->wpos == w)
         w++;

      s->lcode = cc;
	  s->pos = 0x1000000L;

      s->wpos = w;
      s->wc = 1;
      RestoreStreamPos(s->op[0]);
      return TRUE;

    case TY_AND:

    xm:

      ii = 0;
      if (!WAdStream(s->op[0], cc, w, frobno, bEnd))
         return FALSE;

      maxcode = s->op[0]->lcode;
      maxpos = s->op[0]->pos;
      for (i = 1; i < s->ops; i++) {
         if (!WAdStreamp(s->op[i], s->op[0]->lcode, s->op[0]->pos, bEnd))
            return FALSE;

         if (poscmp(s->op[i]->lcode, s->op[i]->pos, maxcode, maxpos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      if (ii == -1)
         return FALSE;

      bb = TRUE;

      for (i = 0; i < s->ops; i++) {
         if (i == ii)
            continue;
         if (!WAdStreamp(s->op[i], s->op[ii]->lcode, s->op[ii]->pos, bEnd))
            return FALSE;
         bb &= (s->op[ii]->lcode == s->op[i]->lcode)
            && (s->op[ii]->pos == s->op[i]->pos);
      }

      if (!bb) {
         cc = s->op[ii]->lcode;
         w = s->op[ii]->wpos + 1;
         goto xm;
      }
      s->pos = s->op[0]->pos;
      s->wpos = s->op[0]->wpos;
      s->lcode = s->op[0]->lcode;
      s->wc = s->op[0]->wc;
      s->lw = s->op[0]->lw;
      s->lw0 = s->op[0]->lw0;

      return TRUE;

/*
 * These cases make no sense and must not be called.
 *
 *  case TY_IDC:
 *    wx = w;
 *    do {
 *       if (!WAdStream(s->op[0], cc, wx, bEnd))
 *          return FALSE;
 *       bOK = bIDValOK(s);
 *       wx = s->op[0]->wpos + 1;
 *    } while (!bOK);
 *
 *    CopyProps(s, 0);
 *    return TRUE;
 *
 *  case TY_ID:
 *    posx = pos;
 *    do {
 *       if (!WAdStreamp(s->op[0], cc, wx, bEnd))
 *          return FALSE;
 *       if (vars[s->kvar].bSet && vars[s->kvar].setter != s)
 *          bOK = s->op[0]->wpos == vars[s->kvar].val;
 *       else {
 *          vars[s->kvar].bSet = TRUE;
 *          vars[s->kvar].setter = s;
 *          vars[s->kvar].val = (int) s->op[0]->wpos;
 *          bOK=TRUE;
 *       }
 *       x = s->op[0]->wpos + 1;
 *    } while (!bOK);
 *
 *    CopyProps(s,0);
 *    return TRUE;
 *
 */                      
case TY_CASE:
	 
	if (!WAdStream(s->op[0], cc, w, frobno, bEnd)) return FALSE;
    while (!bFilterCase(s->op[0]->pos, s->op[0]->lcode,
                          s->xword, s->op[0]->frobpos, s->op[0]->lw))
		if (!AdvanceStream(s->op[0])) return FALSE;
	CopyProps(s,0);
	return TRUE;	

default:
      corperr("Missing case", NULL);
      return FALSE;
   }
}


BOOL WAdStreamp(struct stream *s, sara_ulong cc, sara_long pos, BOOL bEnd)
{
   int            kf;
   int            i;
   int            j;
   sara_long      n;
   int            kp;
   int            kq;
   sara_long      lp;
   sara_long      posx;
   sara_ulong    cx;
   int            ii;
   sara_ulong     mincode;
   sara_ulong     maxcode;
   sara_long      minpos;
   sara_long      maxpos;
   BOOL           bOK;
   BOOL           bb;

   switch (s->type) {

    case TY_ATOM:
      if (s->cursor == -1)
         AdvanceStream(s);

/*
      if (bEnd && s->wtype==ID_WORD)
         w--;
 */
      if (s->lcode > cc)
         return FALSE;

      if (s->pos >= pos && s->lcode == cc)
         return TRUE;

      CalcK(s, &kf, &kp);
      kp++;
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf < s->lf) {
         sara_long  ic = cc - b[i]->locs[maxiloc - 1].lcode;

         lp = b[i]->locs[maxiloc - 1].pos;
         if (ic < 0 || (ic == 0 && lp >= pos))
            break;

         kf++;
         i = ReadStreamIndex(s, kf);
         n += maxiloc - kp;
         kp = 0;
      }

      kq = maxiloc;

      if (kf == s->lf) {
         sara_long  ic = cc - b[i]->locs[s->last - 1].lcode;

         lp = b[i]->locs[s->last - 1].pos;
         if (ic > 0 || (ic == 0 && lp < pos))
            return FALSE;

         kq = s->last;
      }

      j = BinChopp(i, kp, kq - 1, cc, pos);
      n += j - kp + 1;
      s->cursor = n;
      return SetPos(s);

    case TY_ID:
      posx = pos;
      do {
         if (!WAdStreamp(s->op[0], cc, posx, bEnd))
            return FALSE;

         if (vars[s->kvar].bSet && vars[s->kvar].setter != s)
            bOK = s->op[0]->wpos == vars[s->kvar].val;
         else {
            vars[s->kvar].bSet = TRUE;
            vars[s->kvar].setter = s;
            vars[s->kvar].val = (int) s->op[0]->wpos;
            bOK = TRUE;
         }
         posx = s->op[0]->pos + 1;
      }

      while (!bOK);
      CopyProps(s, 0);
      return TRUE;

    case TY_IDC:
      posx = pos;     
      cx=cc;
      do {
         if (!WAdStreamp(s->op[0], cx, posx, bEnd))
            return FALSE;
         bOK = bIDValOK(s);
         posx = s->op[0]->pos + 1;     
         cx=s->op[0]->lcode;
      }

      while (!bOK);
      CopyProps(s, 0);
      return TRUE;

    case TY_FILE:
      if (s->cursor == -1)
         AdvanceStream(s);

/*
      if (bEnd && s->wtype==ID_WORD)
         w--;
 */
      if ((s->pos >= pos && s->lcode == cc) || s->lcode > cc)
         return TRUE;

      CalcK(s, &kf, &kp);
      kp++;
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf < s->lf) {
         sara_long  ic = cc - b[i]->locs1[maxiloc - 1].lcode;

         lp = b[i]->locs1[maxiloc - 1].pos;
         if (ic < 0 || (ic == 0 && lp >= pos))
            break;

         kf++;
         i = ReadStreamIndex(s, kf);
         n += maxiloc - kp;
         kp = 0;
      }

      kq = maxiloc;

      if (kf == s->lf) {
         sara_long  ic = cc - b[i]->locs1[s->last - 1].lcode;

         lp = b[i]->locs1[s->last - 1].pos;
         if (ic > 0 || (ic == 0 && lp < pos))
            return FALSE;
         kq = s->last;
      }

      j = BinChop1p(i, kp, kq - 1, cc, pos);
      n += j - kp + 1;
      s->cursor = n;
      SetPos(s);
      return TRUE;

    case TY_SUBCORPUS:
      i = ReadSubCorpus(s);

      for (j = 0; j < i; j++)
         if (scbuff[j] >= cc)
            break;

      if (j == i)
         return FALSE;

      s->cursor = j;
      SetPos(s);
      return TRUE;

    case TY_SEQ:
      {
         BOOL     b,
                  b1;
         BOOL     bAll;
         WORDNO   
                  i0,
                  i1;
		 int f0, f1;
		 BOOL bStrict;

         bAll = TRUE;
         for (i = 0; i < s->ops; i++) {
            if (s->op[i]->bOptional)
               if (s->op[i]->cursor == -1)
                  WAdStreamp(s->op[i], cc, pos, bEnd);
               else;
            else
               bAll &= WAdStreamp(s->op[i], cc, pos, bEnd);
         }

       xd:

         if (!bAll)
            return FALSE;

         maxcode = 0;
         maxpos = 0;
         ii = -1;

         for (i = 0; i < s->ops; i++)
            if (!s->op[i]->bOptional
                && poscmp(s->op[i]->lcode, s->op[i]->pos,
                          maxcode, maxpos)) {
               maxcode = s->op[i]->lcode;
               maxpos = s->op[i]->pos;
               ii = i;
            }

//         wi = s->op[ii]->wpos;
         b = TRUE;
//         i0 = wi + s->op[ii]->wc;
		 NextWord(s->op[ii],&i0,&f0);

         for (i = ii + 1; i < s->ops; i++) {
            BOOL  b2;

            b1 = b2 = WAdStream(s->op[i], maxcode, i0, f0, FALSE);
            if (b1) FakePos(s->op[i],s->op[i-1]->pos+1);
            b1 &= (s->op[i]->wpos == i0)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos>s->op[i - 1]->pos) && CompatFrob(f0,s->op[i]->frobno);
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               NextWord(s->op[ii],&i0,&f0);
         }
         PrevWord(s->op[ii],&i1,&f1,&bStrict);

         for (i = ii - 1; i >= 0; i--) {
            BOOL  b2;

            b1 = b2 = WAdStream(s->op[i], maxcode, i1, f1, bStrict);
         	if (b1) FakePos(s->op[i],s->op[i+1]->pos-1);

            if (bTrace)
               if (b1)
                  trace("SEQ", "Fitted %d", i);
               else
                  trace("SEQ", "Failed fit %d", i);
            b1 &= (s->op[i]->wpos + (bStrict?s->op[i]->wc:0) == i1)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos<s->op[i + 1]->pos) && CompatFrob(s->op[i]->frobno,f1);
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               PrevWord(s->op[i],&i1,&f1,&bStrict);;
         }

         if (!b) {
            bAll &= AdvanceStream(s->op[ii]);
            goto xd;
         }
         s->pos = s->op[0]->pos;
         s->wpos = s->op[0]->wpos;
         s->lcode = s->op[0]->lcode;
         s->lw = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos)) + (s->op[LastIndex(s)]->lw);
         s->lw0 = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos));
         s->wc = (int) (i0 - i1);
         return TRUE;
      }

    case TY_OR:
      ii = -1;
      mincode = 0x1000000L;
      minpos = 0x1000000L;

      for (i = 0; i < s->ops; i++) {
         if (!WAdStreamp(s->op[i], cc, pos, bEnd))
            continue;

         if (poscmp(mincode, minpos, s->op[i]->lcode, s->op[i]->pos)) {
            ii = i;
            mincode = s->op[i]->lcode;
            minpos = s->op[i]->pos;
         }
      }

      if (ii < 0)
         return FALSE;

      s->pos = s->op[ii]->pos;
      s->wpos = s->op[ii]->wpos;
      s->lcode = s->op[ii]->lcode;
	  s->frobno = s->op[ii]->frobno;
      return TRUE;

    case TY_AND:

    xm:

      ii = -1;
      maxcode = 0;
      maxpos = 0;

      for (i = 0; i < s->ops; i++) {
         if (!WAdStreamp(s->op[i], cc, pos, bEnd))
            return FALSE;

         if (poscmp(s->op[i]->lcode, s->op[i]->pos, maxcode, maxpos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      if (ii == -1)
         return FALSE;

      bb = TRUE;

      for (i = 0; i < s->ops; i++) {
         if (i == ii)
            continue;

         if (!WAdStreamp(s->op[i], s->op[ii]->lcode, s->op[ii]->pos, bEnd))
            return FALSE;
         bb &= (s->op[ii]->lcode == s->op[i]->lcode)
            && (s->op[ii]->pos == s->op[i]->pos);
      }

      if (!bb) {
         cc = s->op[ii]->lcode;
         pos = s->op[ii]->pos + 1;
         goto xm;
      }

      s->pos = s->op[0]->pos;
      s->wpos = s->op[0]->wpos;
      s->lcode = s->op[0]->lcode;
      s->wc = s->op[0]->wc;
      s->lw = s->op[0]->lw;
      s->lw0 = s->op[0]->lw0;
      return TRUE;

    case TY_ALL:
/*
      if (bEnd)
         w--;
 */
      s->lcode = cc;
      s->pos = pos;
      s->wc = 1;
      return TRUE;

    case TY_NEG:
/*
      if (bEnd)
         w--;
 */
      SaveStreamPos(s->op[0]);

/*
      while (WAdStreamp(s->op[0],cc,pos,bEnd) && s->op[0]->wpos == w)
         w++;
 */
      s->lcode = cc;
      s->pos = pos;
      s->wc = 1;
      RestoreStreamPos(s->op[0]);
      return TRUE;

case TY_CASE:
	 
	if (!WAdStreamp(s->op[0], cc, pos, bEnd)) return FALSE;
    while (!bFilterCase(s->op[0]->pos, s->op[0]->lcode,
                          s->xword, s->op[0]->frobpos, s->op[0]->lw))
		if (!AdvanceStream(s->op[0])) return FALSE;
	CopyProps(s,0);
	return TRUE;	

    default:
      corperr("Missing case", NULL);
      return FALSE;
   }
}

int BinChop(int ip, int i1, int i2, sara_long cc, WORDNO w)
{
   int         i;
   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2) / 2;
      c1 = b[ip]->locs[i].lcode - cc;

      if (c1 > 0)
         i2 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs[i].word - w;
         if (c2 > 0)
            i2 = i;
         else if (c2 == 0)
            return i;
         else
            i1 = i + 1;
      } else
         i1 = i + 1;
   }

   return i1;
}


int BinChopp(int ip, int i1, int i2, sara_long cc, sara_long pos)
{
   int         i;
   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2) / 2;
      c1 = b[ip]->locs[i].lcode - cc;

      if (c1 > 0)
         i2 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs[i].pos - pos;
         if (c2 > 0)
            i2 = i;
         else if (c2 == 0)
            return i;
         else
            i1 = i + 1;
      } else
         i1 = i + 1;
   }

   return i1;
}


int BinChop1(int ip, int i1, int i2, sara_long cc, WORDNO w)
{
   int         i;
   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2) / 2;
      c1 = b[ip]->locs1[i].lcode - cc;

      if (c1 > 0)
         i2 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs1[i].word - w;
         if (c2 > 0)
            i2 = i;
         else if (c2 == 0)
            return i;
         else
            i1 = i + 1;
      } else
         i1 = i + 1;
   }

   return i1;
}


int BinChop1p(int ip, int i1, int i2, sara_long cc, sara_long pos)
{
   int         i;
   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2) / 2;
      c1 = b[ip]->locs1[i].lcode - cc;

      if (c1 > 0)
         i2 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs1[i].pos - pos;
         if (c2 > 0)
            i2 = i;
         else if (c2 == 0)
            return i;
         else
            i1 = i + 1;
      } else
         i1 = i + 1;
   }

   return i1;
}


int BinChopb(int ip, int i1, int i2, sara_long cc, WORDNO w)
{
   int         i;
   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2 + 1) / 2;
      c1 = b[ip]->locs[i].lcode - cc;

      if (c1 < 0)
         i1 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs[i].word - w;
         if (c2 < 0)
            i1 = i;
         else if (c2 == 0)
            return i;
         else
            i2 = i - 1;
      } else
         i2 = i - 1;
   }

   return i1;
}


int BinChopbp(int ip, int i1, int i2, sara_long cc, sara_long pos)
{
   int         i;
   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2 + 1) / 2;
      c1 = b[ip]->locs[i].lcode - cc;

      if (c1 < 0)
         i1 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs[i].pos - pos;
         if (c2 < 0)
            i1 = i;
         else if (c2 == 0)
            return i;
         else
            i2 = i - 1;
      } else
         i2 = i - 1;
   }

   return i1;
}


int BinChop1bp(int ip, int i1, int i2, sara_long cc, sara_long pos)
{
   int         i;
   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2 + 1) / 2;
      c1 = b[ip]->locs1[i].lcode - cc;

      if (c1 < 0)
         i1 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs1[i].pos - pos;
         if (c2 < 0)
            i1 = i;
         else if (c2 == 0)
            return i;
         else
            i2 = i - 1;
      } else
         i2 = i - 1;
   }

   return i1;
}

int BinChop1b(int ip, int i1, int i2, sara_long cc, WORDNO w)
{
   int         i;
   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2 + 1) / 2;
      c1 = b[ip]->locs1[i].lcode - cc;

      if (c1 < 0)
         i1 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs1[i].word - w;
         if (c2 < 0)
            i1 = i;
         else if (c2 == 0)
            return i;
         else
            i2 = i - 1;
      } else
         i2 = i - 1;
   }

   return i1;
}


BOOL WAdStreamb(struct stream *s, sara_ulong cc, WORDNO w, int frobno, BOOL bEnd)
{
   int            kf;
   int            i;
   int            j;
   sara_long      n;
   int            kp;
   int            kq;
   WORDNO         lw;
   int            ii;
   sara_ulong     maxcode;
   sara_long      maxpos;
   BOOL           bb;

   switch (s->type) {

    case TY_ATOM:
    	if (s->frobno != -1 && frobno != -1 && s->frobno < frobno && !bEnd ) w--;

      if ((s->wpos <= w && s->lcode == cc) || s->lcode < cc)
         return TRUE;

      if (bEnd && WordStream(s))
         w--;

      CalcK(s, &kf, &kp);
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf > s->ff) {
         sara_long  ic = cc - b[i]->locs[0].lcode;

         lw = b[i]->locs[0].word;
         if (ic > 0 || (ic == 0 && lw <= w))
            break;

         kf--;
         i = ReadStreamIndex(s, kf);
         n -= kp;
         kp = maxiloc;
      }
      kq = 0;

      if (kf == s->ff) {
         sara_long  ic = cc - b[i]->locs[s->first].lcode;

         lw = b[i]->locs[s->first].word;
         if (ic < 0 || (ic == 0 && lw > w))
            return FALSE;
         kq = s->first;
      }

/*
      for (j = kp - 1; j >= kq; j--) {
         sara_long  ic = cc - b[i].locs[j].lcode;
         if (ic > 0 || (ic == 0 && b[i].locs[j].word <= w))
            break;
      }
 */

      j = BinChopb(i, kq, kp - 1, cc, w);
      n -= kp - j;
      s->cursor = n;
      SetPos(s);
      return TRUE;

case TY_FILE:
      if (s->cursor < CountStream(s))
         if ((s->wpos <= w && s->lcode == cc) || s->lcode < cc)
            return TRUE;
      CalcK(s, &kf, &kp);

      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf > s->ff) {
         sara_long  ic = cc - b[i]->locs1[0].lcode;

         lw = b[i]->locs1[0].word;
         if (ic > 0 || (ic == 0 && lw <= w))
            break;
         kf--;
         i = ReadStreamIndex(s, kf);
         n -= kp;
         kp = maxiloc;
      }
      kq = 0;

      if (kf == s->ff) {
         sara_long  ic = cc - b[i]->locs1[s->first].lcode;

         lw = b[i]->locs1[s->first].word;
         if (ic < 0 || (ic == 0 && lw > w))
            return FALSE;
         kq = s->first;
      }

      j = BinChop1b(i, kq, kp - 1, cc, w);
      n -= kp - j;
      s->cursor = n;
      SetPos(s);
      return TRUE;
    case TY_OR:
      ii = -1;
      maxcode = 0L;
      maxpos = 0L;

      for (i = 0; i < s->ops; i++) {
         SaveStreamPos(s->op[i]);
         if (!WAdStreamb(s->op[i], cc, w, frobno, FALSE))
            continue;

         if (poscmp(s->op[i]->lcode, s->op[i]->pos, maxcode, maxpos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      for (i = 0; i < s->ops; i++)
         if (i != ii)
            RestoreStreamPos(s->op[i]);

      if (ii == -1)
         return FALSE;
      s->pos = s->op[ii]->pos;
      s->wpos = s->op[ii]->wpos;
      s->lcode = s->op[ii]->lcode;
	  s->frobno = s->op[ii]->frobno;
      return TRUE;

    case TY_SEQ:
      {
         BOOL     b,
                  b1;
         BOOL     bAll;
         WORDNO   
                  i0,
                  i1;
		 int f0, f1;
		 BOOL bStrict;

         bAll = TRUE;
         for (i = 0; i < s->ops; i++) {
            if (s->op[i]->bOptional)
               if (s->op[i]->cursor == -1)
                  WAdStreamb(s->op[i], cc, w, frobno, FALSE);
               else;
            else
               bAll &= WAdStreamb(s->op[i], cc, w, frobno, FALSE);
         }
       xd:
         if (!bAll)
            return FALSE;

         maxcode = 0x7fffffffL;
         maxpos = 0x7fffffffL;
         ii = -1;

         for (i = 0; i < s->ops; i++)
            if (   !s->op[i]->bOptional
                && poscmp(maxcode, maxpos, s->op[i]->lcode,
                          s->op[i]->pos)) {
               maxcode = s->op[i]->lcode;
               maxpos = s->op[i]->pos;
               ii = i;
            }

//        wi = s->op[ii]->wpos;
         b = TRUE;
//         i0 = wi + s->op[ii]->wc;
			NextWord(s->op[ii],&i0,&f0);
         for (i = ii + 1; i < s->ops; i++) {
            BOOL  b2;

            b1 = b2 = WAdStreamb(s->op[i], maxcode, i0, frobno, FALSE);
            if (b1) FakePos(s->op[i],s->op[i-1]->pos+1);
            
            b1 &= (s->op[i]->wpos == i0)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos>s->op[i - 1]->pos) && CompatFrob(f0,s->op[i]->frobno);                  ;
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               NextWord(s->op[ii],&i0,&f0);
         }
         PrevWord(s->op[ii],&i1,&f1,&bStrict);
         for (i = ii - 1; i >= 0; i--) {
            BOOL  b2;

            b1 = b2 = WAdStreamb(s->op[i], maxcode, i1, f1, bStrict);
         	if (b1) FakePos(s->op[i],s->op[i+1]->pos-1);

            if (bTrace)
               if (b1)
                  trace("SEQ", "Fitted %d", i);
               else
                  trace("SEQ", "Failed fit %d", i);
            b1 &= (s->op[i]->wpos + (bStrict?s->op[i]->wc:0) == i1)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos<s->op[i + 1]->pos) && CompatFrob(s->op[i]->frobno,f1);
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               PrevWord(s->op[i],&i1,&f1,&bStrict);
         }

         if (!b) {
            cc = s->op[ii]->lcode;
            w = s->op[ii]->wpos;    
            bAll &= WAdStreamb(s->op[ii],cc,w-1, f1, FALSE);

            goto xd;
         }
         s->pos = s->op[0]->pos;
         s->wpos = s->op[0]->wpos;
         s->lcode = s->op[0]->lcode;
         s->lw = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos)) + (s->op[LastIndex(s)]->lw);
         s->lw0 = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos));
         s->wc = (int) (i0 - i1);
         return TRUE;
      }

    case TY_AND:

    xm:

      ii = -1;
      maxcode = 0x7fffffffL;
      maxpos = 0x7fffffffL;
      for (i = 0; i < s->ops; i++) {
         if (!WAdStreamb(s->op[i], cc, w, frobno, FALSE))
            continue;

         if (poscmp(maxcode, maxpos, s->op[i]->lcode, s->op[i]->pos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      if (ii == -1)
         return FALSE;

      bb = TRUE;
      for (i = 0; i < s->ops; i++) {
         if (i == ii)
            continue;

         if (!WAdStreamb(s->op[i], s->op[ii]->lcode, s->op[ii]->wpos, s->op[ii]->frobno, FALSE))
            return FALSE;
         bb &= (s->op[ii]->lcode == s->op[i]->lcode)
            && (s->op[ii]->wpos == s->op[i]->wpos);
      }

      if (!bb) {
         cc = s->op[ii]->lcode;
         w = s->op[ii]->wpos;
         goto xm;
      }
      s->pos = s->op[ii]->pos;
      s->wpos = s->op[ii]->wpos;
      s->lcode = s->op[ii]->lcode;
      s->wc = s->op[ii]->wc;
      return TRUE;

    case TY_ALL:
      s->lcode = cc;
      s->wpos = w;
      return TRUE;                  
    case TY_CASE:
			if (!WAdStreamb(s->op[0], cc, w, frobno, bEnd)) return FALSE;
    		while (!bFilterCase(s->op[0]->pos, s->op[0]->lcode,
                          s->xword, s->op[0]->frobpos, s->op[0]->lw))
				if (!RegressStream(s->op[0])) return FALSE;
			CopyProps(s,0);
			return TRUE;	


   }
	return TRUE; // unused
}


BOOL WAdStreambp(struct stream *s, sara_ulong cc, sara_long pos, BOOL bEnd)
{
   int            kf;
   int            i;
   int            j;
   sara_long      n;
   int            kp;
   int            kq;
   sara_long      lp;
   int            ii;
   sara_ulong     maxcode;
   sara_long      maxpos;
   BOOL           bb;
   sara_long      posx;
   sara_ulong     cx;
   BOOL           bOK;

   switch (s->type) {

    case TY_ATOM:
      pos -= s->frobpos;
      if (s->cursor < CountStream(s))
         if ((s->pos <= pos && s->lcode == cc) || s->lcode < cc)
            return TRUE;

      CalcK(s, &kf, &kp);
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf > s->ff) {
         sara_long  ic = cc - b[i]->locs[0].lcode;

         lp = b[i]->locs[0].pos;
         if (ic > 0 || (ic == 0 && lp <= pos))
            break;
         kf--;
         i = ReadStreamIndex(s, kf);
         n -= kp;
         kp = maxiloc;
      }
      kq = 0;

      if (kf == s->ff) {
         sara_long  ic = cc - b[i]->locs[s->first].lcode;

         lp = b[i]->locs[s->first].pos;
         if (ic < 0 || (ic == 0 && lp > pos))
            return FALSE;
         kq = s->first;
      }

      j = BinChopbp(i, kq, kp - 1, cc, pos);
      n -= kp - j;
      s->cursor = n;
      SetPos(s);
      return TRUE;

    case TY_ID:

/*
      if (   s->op[0]->lcode < cc || s->op[0]->lcode == cc
          && s->op[0]->pos<pos)
          return TRUE;
 */
      if (!WAdStreambp(s->op[0], cc, pos, FALSE))
         return FALSE;

      if (s->op[0]->lcode != cc)
         return FALSE;

      if (vars[s->kvar].bSet && vars[s->kvar].setter != s) {
         int         kf;
         int         kp;
         int         i;
         sara_long   n;

         CalcK(s->op[0], &kf, &kp);
         i = ReadStreamIndex(s->op[0], kf);
         n = s->op[0]->cursor;

         while (b[i]->locs[kp].lcode == cc && n >= 0) {
            if (b[i]->locs[kp].word == vars[s->kvar].val)
               break;
            kp--;
            n--;
            if (kp < 0) {
               kp = maxiloc - 1;
               kf--;
               i = ReadStreamIndex(s->op[0], kf);
            }
         }

         if (b[i]->locs[kp].lcode != cc || n < 0)
            return FALSE;
         s->op[0]->cursor = n;
         SetPos(s->op[0]);
      } else {
         vars[s->kvar].bSet = TRUE;
         vars[s->kvar].setter = s;
         vars[s->kvar].val = (int) s->op[0]->wpos;
      }

      CopyProps(s, 0);
      return TRUE;

    case TY_IDC:
      posx = pos;
      cx = cc;
      do {
         if (!WAdStreambp(s->op[0], cx, posx, FALSE))
            return FALSE;
         bOK = bIDValOK(s);
         cx = s->op[0]->lcode;
         posx = s->op[0]->pos - 1;
      } while (!bOK);

      CopyProps(s, 0);
      return TRUE;

    case TY_FILE:
/*
      if (bEnd && s->wtype == ID_WORD)
         w--;
 */
      if (s->cursor < CountStream(s))
         if ((s->pos <= pos && s->lcode == cc) || s->lcode < cc)
            return TRUE;
      CalcK(s, &kf, &kp);

      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf > s->ff) {
         sara_long  ic = cc - b[i]->locs1[0].lcode;

         lp = b[i]->locs1[0].pos;
         if (ic > 0 || (ic == 0 && lp <= pos))
            break;
         kf--;
         i = ReadStreamIndex(s, kf);
         n -= kp;
         kp = maxiloc;
      }
      kq = 0;

      if (kf == s->ff) {
         sara_long  ic = cc - b[i]->locs1[s->first].lcode;

         lp = b[i]->locs1[s->first].pos;
         if (ic < 0 || (ic == 0 && lp > pos))
            return FALSE;
         kq = s->first;
      }

      j = BinChop1bp(i, kq, kp - 1, cc, pos);
      n -= kp - j;
      s->cursor = n;
      SetPos(s);
      return TRUE;

/*
      j = BinChopbp(i,kq,kp-1,cc,pos);
 */

    case TY_SEQ:
      {
         BOOL     b,
                  b1;
         BOOL     bAll;
         WORDNO   
                  i0,
                  i1;
		 int f0, f1;
		 BOOL bStrict;

         bAll = TRUE;
         for (i = 0; i < s->ops; i++) {
            if (s->op[i]->bOptional)
               if (s->op[i]->cursor == -1)
                  WAdStreambp(s->op[i], cc, pos, FALSE);
               else;
            else
               bAll &= WAdStreambp(s->op[i], cc, pos, FALSE);
         }
       xd:
         if (!bAll)
            return FALSE;

         maxcode = 0x7fffffffL;
         maxpos = 0x7fffffffL;
         ii = -1;

         for (i = 0; i < s->ops; i++)
            if (   !s->op[i]->bOptional
                && poscmp(maxcode, maxpos, s->op[i]->lcode,
                          s->op[i]->pos)) {
               maxcode = s->op[i]->lcode;
               maxpos = s->op[i]->pos;
               ii = i;
            }

//         wi = s->op[ii]->wpos;
         b = TRUE;
//         i0 = wi + s->op[ii]->wc;
		 NextWord(s->op[ii],&i0,&f0);

         for (i = ii + 1; i < s->ops; i++) {
            BOOL  b2;

            b1 = b2 = WAdStreamb(s->op[i], maxcode, i0, f0, FALSE);
            if (b1) FakePos(s->op[i],s->op[i-1]->pos+1);
            
            b1 &= (s->op[i]->wpos == i0)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos>s->op[i - 1]->pos) && CompatFrob(f0,s->op[i]->frobno);                  ;
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               NextWord(s->op[i],&i0,&f0);
         }

//         i1 = wi;
		 PrevWord(s->op[ii],&i1,&f1,&bStrict);
         for (i = ii - 1; i >= 0; i--) {
            BOOL  b2;

            b1 = b2 = WAdStreamb(s->op[i], maxcode, i1, f1, bStrict);
            if (b1) FakePos(s->op[i],s->op[i+1]->pos-1);
            
            if (bTrace)
               if (b1)
                  trace("SEQ", "Fitted %d", i);
               else
                  trace("SEQ", "Failed fit %d", i);
            b1 &= (s->op[i]->wpos + (bStrict?s->op[i]->wc:0) == i1)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos<s->op[i + 1]->pos)&& CompatFrob(s->op[i]->frobno,f1);
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               PrevWord(s->op[i],&i1,&f1,&bStrict);
         }

         if (!b) {
            cc = s->op[ii]->lcode;
            pos = s->op[ii]->pos;    
            bAll &= WAdStreambp(s->op[ii],cc,pos-1,FALSE);

            goto xd;
         }
         s->pos = s->op[0]->pos;
         s->wpos = s->op[0]->wpos;
         s->lcode = s->op[0]->lcode;
         s->lw = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos)) + (s->op[LastIndex(s)]->lw);
         s->lw0 = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos));
         s->wc = (int) (i0 - i1);
         return TRUE;
      }

    case TY_OR:
      ii = -1;
      maxcode = 0L;
      maxpos = 0L;

      for (i = 0; i < s->ops; i++) {
         SaveStreamPos(s->op[i]);
         if (!WAdStreambp(s->op[i], cc, pos, FALSE))
            continue;

         if (poscmp(s->op[i]->lcode, s->op[i]->pos, maxcode, maxpos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      for (i = 0; i < s->ops; i++)
         if (i != ii)
            RestoreStreamPos(s->op[i]);

      if (ii == -1)
         return FALSE;

      s->pos = s->op[ii]->pos;
      s->wpos = s->op[ii]->wpos;
      s->lcode = s->op[ii]->lcode;
	  s->frobno = s->op[ii]->frobno;
      return TRUE;

    case TY_AND:

    xm:

      ii = -1;
      maxcode = 0x7fffffffL;
      maxpos = 0x7fffffffL;
      for (i = 0; i < s->ops; i++) {
         if (!WAdStreambp(s->op[i], cc, pos, FALSE))
            return FALSE;

         if (poscmp(maxcode, maxpos, s->op[i]->lcode, s->op[i]->pos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      if (ii == -1)
         return FALSE;

      bb = TRUE;
      for (i = 0; i < s->ops; i++) {
         if (i == ii)
            continue;

         if (!WAdStreambp(s->op[i], s->op[ii]->lcode, s->op[ii]->pos, FALSE))
            return FALSE;
         bb &= (s->op[ii]->lcode == s->op[i]->lcode)
            && (s->op[ii]->pos == s->op[i]->pos);
      }

      if (!bb) {
         cc = s->op[ii]->lcode;
         pos = s->op[ii]->pos - 1;
         goto xm;
      }
      s->pos = s->op[0]->pos;
      s->wpos = s->op[0]->wpos;
      s->lcode = s->op[0]->lcode;
      s->wc = s->op[0]->wc;
      s->lw = s->op[0]->lw;
      s->lw0 = s->op[0]->lw0;
      return TRUE;

    case TY_ALL:
      s->lcode = cc;
      s->pos = pos;
      return TRUE;          
    case TY_CASE:
	 
		if (!WAdStreambp(s->op[0], cc, pos, bEnd)) return FALSE;
    	while (!bFilterCase(s->op[0]->pos, s->op[0]->lcode,
                          s->xword, s->op[0]->frobpos, s->op[0]->lw))
			if (!RegressStream(s->op[0])) return FALSE;
		CopyProps(s,0);
		return TRUE;	

  
   }
	return TRUE; // unused
}

BOOL SetPos(struct stream *s)
{
   if (s->cursor < 0)
      return FALSE;

   switch (s->type) {
      int   kf,
            kp,
            ik;

    case TY_ATOM:
      if (!CalcK(s, &kf, &kp))
         return FALSE;
      ik = ReadIndex(s->ihash, kf);
      s->lcode = b[ik]->locs[kp].lcode;
      s->pos = b[ik]->locs[kp].pos + s->frobpos;
      s->wpos = b[ik]->locs[kp].word;
      return TRUE;

    case TY_FILE:
      if (!CalcK(s, &kf, &kp))
         return FALSE;
      ik = ReadIndexFile(s->handle, kf);
      s->lcode = b[ik]->locs1[kp].lcode;
      s->pos = b[ik]->locs1[kp].pos;
      s->wpos = b[ik]->locs1[kp].word;
      s->lw = b[ik]->locs1[kp].lw;
      s->lw0 = b[ik]->locs1[kp].lw0;
      return TRUE;

    case TY_SUBCORPUS:
      ik = ReadSubCorpus(s);
      if (s->cursor >= ik)
         return FALSE;
      s->lcode = scbuff[s->cursor];
      s->wpos = 0;
      s->pos = 0;
      return TRUE;
   }
	return TRUE; // unused
}


BOOL SetPosEnd(struct stream *s)
{
   switch (s->type) {
      int       ik;

    case TY_ATOM:
      ik = ReadIndex(s->ihash, s->lf);
      s->lcode = b[ik]->locs[s->last - 1].lcode;
      s->pos = b[ik]->locs[s->last - 1].pos;
      s->wpos = b[ik]->locs[s->last - 1].word;
      s->cursor = CountStream(s);
      return TRUE;

    case TY_FILE:
      ik = ReadIndexFile(s->handle, s->lf);
      s->lcode = b[ik]->locs1[s->last - 1].lcode;
      s->pos = b[ik]->locs1[s->last - 1].pos;
      s->wpos = b[ik]->locs1[s->last - 1].word;
      s->lw = b[ik]->locs1[s->last - 1].lw;
      s->lw0 = b[ik]->locs1[s->last - 1].lw0;
      s->cursor = CountStream(s);
      return TRUE;

    case TY_SUBCORPUS:
      s->lcode = 0x7fffffff;
      s->cursor = CountStream(s);
      s->wpos = 0;
      s->pos = 0;
      return TRUE;
   }
	return TRUE; // unused
}


void SavePos(struct stream *s, STRSAVE * n)
{
   *n = s->cursor;
   return;
}


void RestorePos(struct stream *s, STRSAVE * n)
{
   s->cursor = *n;
   return;
}


BOOL CalcK(struct stream *s, int *f, int *p)
{
   sara_long  n = s->cursor;

   *f = s->ff;
   if (s->first + n < maxiloc) {
      *p = s->first + (int) n;
      return s->lf > s->ff || *p < s->last;
   }

   n -= maxiloc - s->first;
   (*f) += (int) (n / maxiloc + 1);
   *p = (int) (n % maxiloc);

   return *f < s->lf || *p < s->last;
}


struct {
   int      k;
   BOOL     bFile;
   union {
      int   hash;
      FILE *f;
   } owner;
   sara_long     use;
} buffercontrol[NBUFF];


void ClearBuffers(void)
{
   int   i;

   for (i = 0; i < NBUFF; i++)
      buffercontrol[i].use = -1;

   return;
}


int ReadIndex(int hash, int k)
{
   int            i;
   char           path[_MAX_PATH];
   FILE          *fIdx;
   struct ihdr    hdr;

   for (i = 0; i < nbt; i++)
      if (   buffercontrol[i].use >= 0
          && buffercontrol[i].owner.hash == hash
          && !buffercontrol[i].bFile
          && buffercontrol[i].k == k) {
         buffercontrol[i].use = nuse++;
         return i;
      }
   i = FreeBuffer();
   IndexFile(hash, k, path);

/*
   if (k == 0)
      sprintf(path,"%s%i.HXX",IndexDir(hash),hash);
   else
      sprintf(path,"%s%i.H%iX",IndexDir(hash),hash,k);
 */

   fIdx = fopen(path, "r");
   fread(&hdr, sizeof(hdr), 1, fIdx);
   fix_ihdr(&hdr, 1);
   fseek(fIdx, (off_t)(sizeof(hdr) + hdr.ndict * sizeof(struct dicent)),
         SEEK_SET);
   fread(b[i], sizeof(struct locent), hdr.nill, fIdx);
   fix_locent(b[i]->locs, hdr.nill);
   fclose(fIdx);

   buffercontrol[i].owner.hash = hash;
   buffercontrol[i].bFile = FALSE;
   buffercontrol[i].k = k;
   buffercontrol[i].use = nuse++;
   nload++;

   return i;
}


void KillFileBuffers(FILE *f)
{
   int   i;

   for (i = 0; i < nbt; i++)
      if (   buffercontrol[i].use >= 0
          && buffercontrol[i].bFile
          && buffercontrol[i].owner.f == f)
         buffercontrol[i].use = -1;
   scbowner = NULL;
   return;
}


int ReadIndexFile(FILE *handle, int k)
{
   int   i;

   for (i = 0; i < nbt; i++)
      if (   buffercontrol[i].use >= 0
          && buffercontrol[i].k == k
          && buffercontrol[i].bFile
          && buffercontrol[i].owner.f == handle) {
         buffercontrol[i].use = nuse++;
         return i;
      }
   i = FreeBuffer();

   fseek(handle, (off_t)(k * maxiloc * sizeof(struct locent)), SEEK_SET);
   fread(b[i], sizeof(struct locent), maxiloc, handle);
//   fix_locent(b[i]->locs, MAXILOC);
//   No! This is a temporary file and will be OK already.
   buffercontrol[i].owner.f = handle;
   buffercontrol[i].bFile = TRUE;
   buffercontrol[i].k = k;
   buffercontrol[i].use = nuse++;

   return i;
}


int ReadStreamIndex(struct stream *s, int k)
{
   if (s->type == TY_ATOM)
      return ReadIndex(s->ihash, k);
   else
      return ReadIndexFile(s->handle, k);
}


int ReadSubCorpus(struct stream *s)
{
   int   n = (int) CountStream(s);

   if (s->handle == scbowner)
      return n;
   scbowner = s->handle;
   fread(scbuff, sizeof(sara_long), n, s->handle);
   return n;
}


int FreeBuffer(void)
{
   int         i;
   int         ii;
   sara_long   minuse = nuse;

   if (bAutoAlloc) {
      b[ii = nba] = malloc(sizeof(union bpage));
      nbt++;
      nba++;
      return ii;
   }
   if (nuse == 0)
      return 0;
   for (i = nba; i < nbt; i++)
      if (buffercontrol[i].use < minuse) {
         ii = i;
         minuse = buffercontrol[i].use;
      }
   return ii;
}


sara_long LastSGML(WORDNO w, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   sara_long      p;

   if (!(s = AccelerateStream(tag, 0, ty, cc)))
      s = MakeAtomStream(tag, 0, ty);
   if (s == NULL)
      return LastSGML(w, cc, txt0, ID_TAGO);
   WindStream(s);

   if (!WAdStreamb(s, cc, w, -1, FALSE)||cc != s->lcode) {
		p=0;
   }
   else p = s->pos;
   FreeStream(s);
   return p;
}


sara_long LastSGMLp(sara_long pos, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   sara_long      p;

   if (!(s = AccelerateStream(tag, 0, ty, cc)))
      s = MakeAtomStream(tag, 0, ty);

   if (s == NULL)
      return LastSGMLp(pos, cc, txt0, ID_TAGO);

   WindStream(s);

   if (!WAdStreambp(s, cc, pos, FALSE) || cc != s->lcode)
      if (!strcmp(tag, txt0))
         p = 0;
      else
/*         p = LastSGMLp(pos, cc, txt0, ID_TAGO); */
		p=0;
   else
      p = s->pos;

   FreeStream(s);
   return p;
}


sara_long NextSGMLp(sara_long pos, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   sara_long      p;
   if (!(s = AccelerateStream(tag, 0, ty, cc)))
      s = MakeAtomStream(tag, 0, ty);

   if (s == NULL)
      return NextSGMLp(pos, cc, txt0, ID_TAGE);

   RewindStream(s);
   AdvanceStream(s);

   if (!WAdStreamp(s, cc, pos, FALSE) || cc != s->lcode)
      if (!strcmp(tag, txt0))
         p = pos + 1000;
      else
         p = NextSGMLp(pos, cc, txt0, ID_TAGE);
   else
      p = s->pos;

   FreeStream(s);
   return p;
}


sara_long NextSGML(WORDNO w, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   sara_long      p;
	SGMLFold(tag);

   if (!(s = AccelerateStream(tag, 0, ty, cc)))
      s = MakeAtomStream(tag, 0, ty);

   if (s == NULL)
      return NextSGML(w, cc, txt0, ID_TAGE);

   RewindStream(s);
   AdvanceStream(s);

   if (!WAdStream(s, cc, w, -1, FALSE) || cc != s->lcode ) {
      if (!strcmp(tag, txt0))
         p = s->pos + 1000;
      else
//		  p = NextSGML(w, cc, txt0, ID_TAGE); }
		  p = NextSGML(0, cc, txt0, ID_TAGE); }
   else 
	p = s->pos;

   FreeStream(s);
   return p;                    /* better error handling here! */
}


struct stream pstream;

struct stream* MakePosStream(char* pos)
{
	struct stream* s; int i=0;
	if (nwt==0) return NULL;
	for (i=0;i<nwt;i++) {
		s=MakeAttStream(wtags[i].name,wtags[i].pos,pos);
		if (s != NULL) break;
	}
	if (s != NULL) s->wc=1;
	return s;
}



struct stream *MakeAtomStream(char *w, int extra, int wtype)
{
   struct stream *s = GrabStream();
   struct lookup  lur;
   int            i;

#if defined(__unix__)
   fflush(stdout);
#endif

   if (s == NULL) {
      return NULL;
   }

   strcpy(lur.word, w);
   strcpy(s->xword, w);

   if (wtype == ID_WORD)
      preproc(lur.word);
	else if (wtype==ID_TAGO||wtype==ID_TAGE) SGMLFold(lur.word);
   if (!LookUpWord(&lur, 0)) {
      FreeStream(s);
      return NULL;
   } else if (!GetPos1(&lur, extra, wtype)) {
      FreeStream(s);
      return NULL;
   }

   s->type = TY_ATOM;
   strcpy(s->word, w);
   i = lur.sel;
   s->ihash = lur.ihash;
   s->extra = extra;
   s->wtype = wtype;
   s->wc = (wtype == ID_WORD) ? 1 : 0;
   s->count = -1;
   s->first = lur.sig[i].first;
   s->ff = lur.sig[i].ff;
   s->last = (i + 1 < lur.nsig) ? lur.sig[i + 1].first : lur.last;
   s->lf = (i + 1 < lur.nsig) ? lur.sig[i + 1].ff : lur.lf;
   s->lw = strlen(lur.word);
   s->lw0=0;

   return s;
}


struct stream *MakeIDStream(char *w, char *d, int wtype)
{
   struct stream *s = GrabStream();
   int            kvar = atoi(w);
   s->op[0] = MakeAtomStream(d, 0, wtype);
   s->ops = 1;
   s->type = TY_ID;
   s->kvar = kvar;
   return s;
}


struct stream *MakeIDCStream(int kx, WORDNO k[10], char *d, int wtype)
{
   int            i;
   struct stream *s = GrabStream();
   s->op[0] = MakeAtomStream(d, 0, wtype);
   if (s->op[0] == 0)
      return NULL;

   s->ops = 1;
   s->type = TY_IDC;
   s->nkvals = kx;

   for (i = 0; i < kx; i++)
      s->kval[i] = k[i];

   return s;
}


#if !defined(SERVER)

void Subquery(void)
{
   while (TRUE)
      switch (Menu(&sqm)) {
         int   i;

       case MN_DISCARD:
         DiscardUnmarked();
         return;

       case MN_SELECTION:
         if (bFilter)
            break;
         EditGetNumber("Select how many? ", &i);
         if (i <= 0)
            break;
         Retain(i, CountStream(&qs));
         return;

       case MN_MAIN:
         return;
      }
}


void SaveQuery(void)
{
   char  nm[MAXNAME + 1];

   if (qs.type == 0) {
      printf("No query to save\n");
      return;
   }

   EditGetWord("Query name: ", nm);
   nm[MAXNAME] = 0;
   SaveQueryFile(&qs, nm);
}

#endif /* ! SERVER */


sara_long SaveQueryFile(struct stream *s, char *n, int *nt)
{
   FILE             *f = NULL;
   struct locent1    l;
   int               i = 0;
   int               j = 0;
   sara_long         m = 0;
   sara_ulong        lc = 0xf000000;

   *nt = 0;

   f = fopen(GetQTPath(n), "w");
   if (f == NULL)
      return -2;

   RewindStream(s);
   l.bNew = FALSE;

   while (XAdvanceStream(s)) {
      if (s->bFilter && i >= nfil)
         break;

      if (s->bFilter && filter[i] > j++)
         continue;

      l.lcode = s->lcode;
      l.pos = s->pos;
      l.word = s->wpos;
      l.lw = s->lw;
	  l.lw0=s->lw0;
	  assert(l.lw >= 0);

      if (!fwrite(&l, sizeof(l), 1, f)) {
         fclose(f);
         f = fopen(GetQPath(n), "w");
         fclose(f);
         return -2;
      }

      if (lc != l.lcode) {
         lc = l.lcode;
         (*nt)++;
      }
      i++;
      m++;
   }

   if (bInt) {
      fclose(f);
      f = fopen(GetQTPath(n), "w");
      fclose(f);
      return -3;
   }

   fclose(f);

   return m;
}

#if !defined(SERVER)

void SaveSubCorpus(void)
{
   char        nm[MAXNAME + 1];
   FILE       *f;
   char        path[_MAX_PATH + 1];
   int         i = 0;
   int         j = 0;
   sara_ulong  lastcode = 0;

   if (qs.type == 0) {
      printf("No query to save\n");
      return;
   }

   EditGetWord("Subcorpus name: ", nm);
   nm[MAXNAME] = 0;
   sprintf(path, "%s%s.scp", etcpath, nm);

   f = fopen(path, "r");
   if (f != NULL) {
      char  msg[MAXNAME + 50];

      fclose(f);
      sprintf(msg, "Subcorpus %s already exists. Overwrite", nm);
      if (!yn(msg))
         return;
   }

   f = fopen(path, "w");
   RewindStream(&qs);

   while (AdvanceStream(&qs)) {
      if (bFilter && i >= nfil)
         break;

      if (bFilter && filter[i] > j++)
         continue;

      if (qs.lcode == lastcode)
         continue;

      fwrite(&qs.lcode, sizeof(lastcode), 1, f);
      lastcode = qs.lcode;
      i++;
   }

   fclose(f);

   return;
}


void LoadQuery(void)
{
   char        nm[MAXNAME + 1];
   FILE       *f;
   char        path[_MAX_PATH];
   sara_long   ss;

   EditGetWord("Query name: ", nm);
   nm[MAXNAME] = 0;
   sprintf(path, "%s%s.sqy", etcpath, nm);

   f = fopen(path, "r");
   if (f == NULL) {
      printf("Query %s not found\n", nm);
      return;
   }

   qs.type = TY_FILE;
   fseek(f, (off_t)0, SEEK_END);
   ss = ftell(f);
   rewind(f);

   qs.count = (int) ss / sizeof(struct locent1);
   qs.first = 0;
   qs.ff = 0;
   qs.last = qs.count % MAXILOC;
   qs.lf = qs.count / MAXILOC;
   qs.handle = f;
   printf("Loaded %i solutions\n", qs.count);

   return;
}

#endif /* ! SERVER */


struct stream *MakeFileStream(char *file)
{
   FILE          *f;
   char           path[_MAX_PATH];
   sara_long      ss;
   struct stream *s;

   sprintf(path, "%s%s.sqy", etcpath, file);

   f = fopen(path, "r");
   if (f == NULL) {
#if !defined(SERVER)
      printf("Query %s not found\n", file);
#endif /* ! SERVER */
      return NULL;
   }

   s = GrabStream();
   s->type = TY_FILE;
   fseek(f, (off_t)0, SEEK_END);
   ss = ftell(f);
   rewind(f);
   s->count = (int) ss / sizeof(struct locent1);
   s->first = 0;
   s->ff = 0;
   s->last = (int) s->count % maxiloc;
   s->lf = (int) s->count / maxiloc;
   s->handle = f;
   s->wc = 1;
   return s;
}


struct stream *MakeSCStream(char *file)
{
   FILE          *f;
   char           path[_MAX_PATH];
   sara_long      ss;
   struct stream *s;

   sprintf(path, "%s%s.scp", etcpath, file);

   f = fopen(path, "r");
   if (f == NULL) {
#if !defined(SERVER)
      printf("Subcorpus %s not found\n", file);
#endif /* ! SERVER */
      return NULL;
   }

   s = GrabStream();
   s->type = TY_SUBCORPUS;
   fseek(f, (off_t)0, SEEK_END);
   ss = ftell(f);
   rewind(f);
   s->count = (int) ss / sizeof(sara_long);
   s->handle = f;
   s->wc = 0;

   return s;
}


BOOL bFilterCase(sara_long pos, sara_ulong code, char *fil, int offs, int l)
{
   char  path[_MAX_PATH] = "";
   FILE *fText;
   int   k;
   char  ins[10];
   char  buff[MAXWORD + 1];

   GetDocPath(code, ins, path);
   fText = fopen(path, "r");
   if (fText==NULL) return TRUE;
   fseek(fText, (off_t)(pos + offs), SEEK_SET);
   k = fread(buff, 1, l + 10, fText);
   buff[k] = 0;

   NormSpaces(buff);
   fclose(fText);
   return !strncmp(fil, buff, strlen(fil));
}


void NormSpaces(char *s)
{
   char *ss = s;

   while (*s) {
      if (isspace(*s)) {
         *ss = ' ';
         s++;
         ss++;
         while (*s && isspace(*s))
            s++;
      } else {
         *ss = *s;
         s++;
         ss++;
      }
   }
   *ss = 0;
}


struct stream *MakeSGMLStream2(char *name, int n, char *attnames[],
                               char *attvals[])
{
   int            i,
                  i0,
                  nx;
   struct stream *s,
                  *s1;
	SGMLFold(name);
   s = MakeAtomStream(name, 0, ID_TAGO);
   if (s == NULL)
      return s;

   s1 = GrabStream();
   s1->type = TY_AND;
   s1->wtype = ID_TAGO;
   s1->op[0] = s;
   s1->wc = 0;
   nx = 1;
   i0 = 0;

   while (i0 < n) {
      struct stream *dis;
      int            k,
                     j,
                     kk;

      i = i0 + 1;

      while (i < n && SameAttribute(name, attnames[i0], attvals[i0],
                                    attnames[i], attvals[i]))
         i++;

      k = i - i0;
      dis = GrabStream();
      dis->type = TY_OR;
      kk = 0;               
      
/* Here we should consolidate multiple seaches of the same IDC stream, as they can already cope with 
disjunctions internally with great efficiency */      

      for (j = 0; j < k; j++) {
         struct stream *a = MakeAttStream(name, attnames[i0 + j],
                                          attvals[i0 + j]);
         if (a)
            dis->op[kk++] = a;
      }

      dis->ops = kk;
      if (kk == 0)
         return NULL;

      if (kk == 1)
         s1->op[nx++] = dis->op[0];
      else
         s1->op[nx++] = dis;
      i0 = i;
   }
   s1->ops = nx;
   return s1;
}


struct stream *MakeSGMLStream(char *name, int n, char *attnames[],
                              char *attvals[])
{
   struct stream *s,
                 *s1;
   int            i,
                  j;
   int            ival;
   s = MakeAtomStream(name, 0, ID_TAGO);

   if (n == 0 || s == NULL)
      return s;

   s1 = GrabStream();
   s1->type = TY_AND;
   s1->wtype = ID_TAGO;
   s1->ops = n + 1;
   s1->op[0] = s;
   s1->wc = 0;

   for (j = 0; j < n; j++) {
      int   at;
      char *p,
           *a0;
      int   kdis = 0;
      char  attdis[10][30];

      for (i = 0; i < natts; i++)
         if (   !_stricmp(attnames[j], atttab[i].name)
             && (   !_stricmp(name, atttab[i].element)
                 || atttab[i].element[0] == '0'))
            break;

      if (i == natts)
         return NULL;
      at = atttab[i].attv & 0x3fff;

      if (at !=AT_CDATA && at !=AT_MULTIDREF)
         _strupr(attvals[j]);

      a0 = attvals[j];

      while ((p = strchr(a0, '|')) != NULL) {
         int   l = p - attvals[j];

         strncpy(attdis[kdis], a0, l);
         attdis[kdis++][l] = 0;
         a0 += l + 1;
      }

      strcpy(attdis[kdis++], a0);
      switch (at) {
         int   ii;

       case AT_NULL:
         s1->op[j + 1] = NULL;
         break;

       case AT_MULTIDREF:
         {
            WORDNO    k;
            WORDNO    kvals[10];
            int       iii;

            for (ii = 0; ii < natts; ii++)
               if (!_stricmp(attnames[j], atttab[ii].name) &&
                   !_stricmp(name, atttab[ii].element) &&
                   idcomp(attdis[0], atttab[ii].attdesc, "000", &k))
                  break;
            for (iii = 0; iii < kdis; iii++)
               idcomp(attdis[iii], atttab[ii].attdesc, "000", kvals + iii);
            s1->op[j + 1] = MakeIDCStream(kdis, kvals,
                                          atttab[ii].attdesc,
                                          atttab[ii].val);
            break;
         }

       case AT_REFID:
         ival = atttab[i].val;
         for (ii = 0; ii < natts; ii++)
            if (!_stricmp(atttab[ii].name, "id") &&
                !_stricmp(atttab[ii].element, atttab[i].attdesc))
               break;
         i = ii;
         goto foo;

       case AT_ID:
         ival = atttab[i].val;

       foo:
         s1->op[j + 1] = MakeIDStream(attvals[j], atttab[i].attdesc, ival);
         break;

       default:
         s1->op[j + 1] = MakeAtomStream(attvals[j], 0, atttab[i].val);
         break;
      }
      if (s1->op[j + 1] == NULL)
         return NULL;
   }
   return s1;
}


BOOL SameAttribute(char *elt, char *a1, char *v1, char *a2, char *v2)
{
   int      i,
            j,
            at;
   WORDNO   k;

   if (strcmp(a1, a2))
      return FALSE;

   for (i = 0; i < natts; i++)
      if (   !_stricmp(a1, atttab[i].name)
          && (!_stricmp(elt, atttab[i].element)
              || atttab[i].element[0] == '0'))
         break;

   if (i == natts)
      return FALSE;
   at = atttab[i].attv & 0x3fff;

   if (at !=AT_MULTIDREF)
      return TRUE;

   for (j = 0; j < natts; j++)
      if (   !_stricmp(a1, atttab[j].name)
          && !_stricmp(elt, atttab[j].element)
          && idcomp(v1, atttab[j].attdesc, "000", &k))
         break;

   if (j == natts)
      return FALSE;

   return idcomp(v2, atttab[j].attdesc, "000", &k);
}


struct stream *MakeAttStream(char *elt, char *attname, char *val)
{
   int            at;
   struct stream *s1;
   int            i,
                  ival;
   char          *p,
                 *a0;
   int            kdis = 0;
   char           attdis[10][30];

   for (i = 0; i < natts; i++)
      if (   !_stricmp(attname, atttab[i].name)
          && (!_stricmp(elt, atttab[i].element)
              || atttab[i].element[0] == '0'))
         break;

   if (i == natts)
      return NULL;
   at = atttab[i].attv & 0x3fff;

   if (at !=AT_CDATA && at !=AT_MULTIDREF)
      _strupr(val);
   a0 = val;

   while ((p = strchr(a0, '|')) != NULL) {
      int   l = p - val;

      strncpy(attdis[kdis], a0, l);
      attdis[kdis++][l] = 0;
      a0 += l + 1;
   }

   strcpy(attdis[kdis++], a0);

   switch (at) {
      int       ii;

    case AT_NULL:
      s1 = NULL;
      break;

    case AT_MULTIDREF:
      {
         WORDNO    k;
         WORDNO    kvals[10];
         int       iii;

         for (ii = 0; ii < natts; ii++)
            if (!_stricmp(attname, atttab[ii].name) &&
                !_stricmp(elt, atttab[ii].element) &&
                idcomp(attdis[0], atttab[ii].attdesc, "000", &k))
               break;    
         if (ii==natts) return NULL;      
         for (iii = 0; iii < kdis; iii++)
            idcomp(attdis[iii], atttab[ii].attdesc, "000", kvals + iii);
		 if (kdis==1) s1=PCQStream(elt, attname,atttab[ii].attdesc,kvals[0]); 		
         if (s1==NULL) s1 = MakeIDCStream(kdis, kvals, atttab[ii].attdesc, atttab[ii].val);
         break;
      }

    case AT_REFID:
      ival = atttab[i].val;
      for (ii = 0; ii < natts; ii++)
         if (!_stricmp(atttab[ii].name, "id") &&
             !_stricmp(atttab[ii].element, atttab[i].attdesc))
            break;
      i = ii;
      goto foo;

    case AT_ID:
      ival = atttab[i].val;

    foo:

      if (isdigit(val[0]))
		s1 = MakeIDStream(val, atttab[i].attdesc, ival);
	  else
	  {
		  WORDNO kval;
		  if (!idcomp(val,atttab[i].attdesc,"000",&kval)) return NULL;
		  s1=MakeIDCStream(1,&kval,atttab[i].attdesc, ival);
	  }
      break;

    default:
      s1 = MakeAtomStream(val, 0, atttab[i].val);
      break;
   }
   return s1;
}


void NewQuery(void)
{

#if !defined(SERVER)
   ClearMarks();
#endif /* ! SERVER */

   bFilter = FALSE;
   bCase = FALSE;
   bHdr = FALSE;

   return;
}


sara_long xscore(struct locent1 *l, struct stream *s, int kwin1, int kwin2)
{
   sara_long   ks = 0;
   WORDNO      w = l->word - kwin1;

   if (w < 0)
      w = 0;

   if (!WAdStream(s, l->lcode, w, -1, FALSE))
      return 0;

   while (s->lcode == l->lcode && s->wpos <= l->word + kwin2) {
      if (s->wpos!=l->word) 
		ks++;
      if (!XAdvanceStream(s))
         break;
   }

   return ks;
}


sara_long cscore(struct stream *s1, struct stream *s2, int kwin)
{
   sara_long  ks = 0;

   while (XAdvanceStream(s1)) {
      WORDNO   w = s1->wpos - kwin;

      if (w < 0)
         w = 0;
      WAdStream(s2, s1->lcode, w, -1, FALSE);

      while (s2->lcode = s1->lcode && s2->wpos <= s1->wpos + kwin) {
         ks++;
         if (!XAdvanceStream(s2))
            return ks;
      }
   }
   return ks;
}


BOOL Get1Sol(sara_ulong text, char *elt, char *att, char *sol)
{

   FreeStreams();
   if (!strcmp(att, "-"))
      return Get1Elt(text, elt, sol);
	return Get1AttText(text,elt,att,sol);
/*
   for (i = 0; i < natts; i++)
      if (!_stricmp(elt, atttab[i].element) && !_stricmp(att, atttab[i].name))
         break;

   if (!(atttab[i].attv & AT_PLURAL))
      return FALSE;

   for (i = 0; i < natts; i++) {
      char      t[20];
      WORDNO    k;

      if (_stricmp(elt, atttab[i].element) || _stricmp(att, atttab[i].name))
         continue;
      if (!Get1Att(atttab[i].attdesc, text, atttab[i].val, &k))
         continue;
      sprintf(t, " %s%d", atttab[i].attdesc, (int) k);
      strcat(sol, t);
   }                                      
   return TRUE;
*/
 }


BOOL Get1AttText(sara_ulong text,char* elt,char* att,char* sol)
{
   struct stream *s1; char tag[1001];
   BOOL           b = TRUE;
   s1 = MakeAtomStream(elt, 0, ID_TAGO);
   if (s1 == NULL)
      return FALSE;

   RewindStream(s1);

   if (!WAdStreamp(s1, text, 0, FALSE) || s1->lcode != text)
      b = FALSE;

   if (b) {
	   FILE * fText; int j; char path[_MAX_PATH]; char id[10];
      GetDocPath(text, id, path);
      if ((fText = fopen(path, "r")) == NULL) {
		syslog(LOG_ERR, "Can't open %s", path);
		return FALSE;
		}
		fseek(fText, (off_t)s1->pos, SEEK_SET);
		fread(tag, 1, 1000, fText);
		fclose(fText);
		tag[1000] = 0;
		for (j=0;j<1000;j++) {
			if (tag[j]=='>') break;
		}
		tag[j+1]=0;
   }

   if (b) {
	   char *s;
	   s=strstr(tag,att);
	   if (s==NULL) b=FALSE;
		s+=strlen(att);
		if (b && *s != '=') b=FALSE;
		s++;
		if (b && *s == '\"') {
			s++;
			while (*s != '\"') {
				*sol++=*s++;
			}
		} else if (b) {
			while (isalnum(*s)) *sol++=*s++;
		}
		*sol=0;
   }


   FreeStream(s1);

   return b;
}


BOOL Get1Att(char *desc, sara_ulong text, int att, WORDNO * k)
{
   struct stream *s;
   BOOL           b = TRUE;

   s = MakeAtomStream(desc, 0, att);

   if (s == NULL)
      return FALSE;

   if (!WAdStream(s, text, 0, -1, FALSE) || s->lcode != text)
      b = FALSE;
   else
      *k = s->wpos;
   FreeStream(s);
   return b;
}


BOOL Get1Elt(sara_ulong text, char *elt, char *sol)
{
   struct stream *s1,
                 *s2;
   BOOL           b = TRUE;
   s1 = MakeAtomStream(elt, 0, ID_TAGO);
   if (s1 == NULL)
      return FALSE;

   s2 = MakeAtomStream(elt, 0, ID_TAGE);

   RewindStream(s1);
   RewindStream(s2);

   if (!WAdStreamp(s1, text, 0, FALSE) || s1->lcode != text)
      b = FALSE;

   if (!WAdStreamp(s2, text, s1->pos, FALSE) || s2->lcode != text)
      b = FALSE;

   if (b)
      TextExtract(text, s1->pos, s2->pos, sol);

   FreeStream(s1);
   FreeStream(s2);

   return b;
}


struct at {
   int            ff[MAXTEXTS + 1];
   int            first[MAXTEXTS + 1];
   struct stream  s;
};
struct at acctab2[ACCMAX];


struct stream *AccelerateStream(char *w, int ex, int ty, sara_ulong cc)
{
   int            i;
   struct stream *s;
	if (ty==ID_TAGO||ty==ID_TAGE) SGMLFold(w);
   for (i = 0; i < nacc; i++)
#ifdef CASE_KLUDGE
      if (!stricmp(w, acctab[i].word) && ty == acctab[i].type
          && ex == acctab[i].extra)
#else
      if (!strcmp(w, acctab[i].word) && ty == acctab[i].type
          && ex == acctab[i].extra)
#endif
         break;

   if (i == nacc)
      return NULL;

   s = &acctab2[i].s;
   s->ff = acctab2[i].ff[cc];
   s->first = acctab2[i].first[cc] - 1; /* -1 because of bug in
                                         * indexer
                                         */
   s->lf = acctab2[i].ff[cc + 1];
   s->last = acctab2[i].first[cc + 1] - 1;
   s->count = -1;
   return s;
}


void SetLimits(struct stream *s, sara_ulong cc)
{
   int   i;

   switch (s->type) {
    case TY_ATOM:
      for (i = 0; i < nacc; i++)
#ifdef CASE_KLUDGE
         if (   !stricmp(s->word, acctab[i].word)
             && s->extra == acctab[i].extra
             && s->wtype == acctab[i].type)
#else
		 if (   !strcmp(s->word, acctab[i].word)
             && s->extra == acctab[i].extra
             && s->wtype == acctab[i].type)
#endif
			 break;

      if (i == nacc)
         return;

      s->ff = acctab2[i].ff[cc];
      s->first = acctab2[i].first[cc] - 1; /* -1 because of bug in
                                            * indexer
                                            */
      s->lf = acctab2[i].ff[cc + 1];
      s->last = acctab2[i].first[cc + 1] - 1;
      s->count = -1;
      return;

    default:
      for (i = 0; i < s->ops; i++)
         SetLimits(s->op[i], cc);
   }
}


BOOL myscanf(FILE *f, char *s, int *type, int *extra)
{
   char  buff[100];

   if (!fgets(buff, sizeof(buff), f))
      return FALSE;

   strcpy(s, strtok(buff, " "));

   *type = atoi(strtok(NULL, " "));
   *extra = atoi(strtok(NULL, " "));

   return TRUE;
}


void GetAccels(void)
{
   int   i;    
   struct stream *s;

   for (i = 0; i < nacc; i++) {
      s = MakeAtomStream(acctab[i].word,
                                     acctab[i].extra, acctab[i].type);
                                     
	  if (s==NULL) {
		  syslog(LOG_WARNING,"Open accelerator stream %d failed",i);
		  continue;
	  }
		else acctab2[i].s=*s;
#if defined(__unix__)
      fflush(stdout);
#endif
      LoadAccel(i);
#if defined(__unix__)
      fflush(stdout);
#endif
   }
}


void LoadAccel(int i)
{
   char  path[_MAX_PATH];
   FILE *f;
   int   j;

   sprintf(path, "%s%i.acc", etcpath, i);
   f = fopen(path, "r");

   for (j = 0; j < ntexts; j++) {
      struct accentry accx;

      fread(&accx, sizeof(accx), 1, f);
      fix_accentry(&accx, 1);
      acctab2[i].ff[j] = accx.y;
      acctab2[i].first[j] = accx.x;
   }

   acctab2[i].ff[ntexts] = acctab2[i].s.lf;
   acctab2[i].first[ntexts] = acctab2[i].s.last;
   fclose(f);
}

struct stream* PCQStream(char* e,char* a,char* v,WORDNO k)
{
	int i;    char name[10];
	for (i=0;i<npc;i++)
		if (!strcmp(e,pcqtab[i].elt) && !strcmp(a,pcqtab[i].att) && !strcmp(v,pcqtab[i].attval) && k== pcqtab[i].val) break;
	if (i==npc) return NULL;
	sprintf(name,"pcq%d",i);
	return MakeFileStream(name);
}	
		

int LastIndex(struct stream* s)
{
	int i;
	for (i=s->ops-1;i>0;i--) {
		if (s->op[i]->type != TY_NEG) return i;
	}
	return 0;
}

BOOL WordStream(struct stream* s)
{
	int i, j;
	if (s->type==ID_WORD) return TRUE;
	for (i=0;i<nwt;i++) {
		for (j=0;j<natts;j++) {
			if (SGMLComp(wtags[i].name,atttab[j].element) &&
				SGMLComp(wtags[i].pos,atttab[j].name))
				break;
		}
		if (j < natts && s->type==atttab[j].val) return TRUE;
	}
	return FALSE;
}

